########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/i_1099.4gs/screen.trg  1.2  Delta: 2/9/91
########################################################################

defaults

    libraries
        ../../all.4gm/lib.a;

    switchbox_items
      paytoz paytoz()   # pay to zoom
      apactvz apactvz() # ap activity zoom
      apinvcz apinvcz() # ap invoice detail
      cdactvz cdactvz() # cash disbursement detail
      apiactz apiactz() # ap invoice activity detail;

input 1
    static_define
        dup_stmt char(128),
        dup_prep char(1);

    after_change_in vend_code
        if dup_chk()
        then 
            call fg_err(1)  # Duplicate vendor code
            let nxt_fld = "vend_code" 
            return 
        end if;

    after_field total_amt
        if p_p1099r.total_amt is null
        then
            let p_p1099r.total_amt = 0
        end if;

    after_change_in total_amt
        let p_p1099r.total_amt = round("a",p_p1099r.total_amt);
    after_change_in cat_1_amt
        let p_p1099r.cat_1_amt = round("a",p_p1099r.cat_1_amt);
    after_change_in cat_2_amt
        let p_p1099r.cat_2_amt = round("a",p_p1099r.cat_2_amt);
    after_change_in cat_3_amt
        let p_p1099r.cat_3_amt = round("a",p_p1099r.cat_3_amt);
    after_change_in cat_4_amt
        let p_p1099r.cat_4_amt = round("a",p_p1099r.cat_4_amt);
    after_change_in cat_5_amt
        let p_p1099r.cat_5_amt = round("a",p_p1099r.cat_5_amt);
    after_change_in cat_6_amt
        let p_p1099r.cat_6_amt = round("a",p_p1099r.cat_6_amt);
    after_change_in cat_7_amt
        let p_p1099r.cat_7_amt = round("a",p_p1099r.cat_7_amt);
    after_change_in cat_8_amt
        let p_p1099r.cat_8_amt = round("a",p_p1099r.cat_8_amt);
    after_change_in cat_9_amt
        let p_p1099r.cat_9_amt = round("a",p_p1099r.cat_9_amt);
    after_change_in cat_10_amt
        let p_p1099r.cat_10_amt = round("a",p_p1099r.cat_10_amt);

    after_input
        # check for required values
        if mustfill(p_p1099r.vend_code, "Vendor Code")   
          then let nxt_fld = "vend_code" end if;

    at_eof

#####################################################################
function dup_chk()
# returns true if a duplicate value in table is found
#####################################################################

define
    p_rowid smallint,
    p_count smallint

    whenever error call error_handler

    if dup_prep is null
    then
        let dup_prep = "Y"
        let scratch = "select count(*) from stp1099r ",
                      "where vend_code = ? and rowid != ?"
        prepare dup_stmt from scratch
        declare dup_cur cursor for dup_stmt
    end if

    let p_rowid = get_scrlib("curs_rowid")

    open dup_cur using p_p1099r.vend_code, p_rowid
    fetch dup_cur into p_count
    close dup_cur

    if p_count > 0 then return true end if

    return false
   
end function
# function dup_chk();
