######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

database standard

globals
    define

        ##############################################################
        # Codegen area
        ##############################################################
        # Global variables in this section will be overwritten
        # during a re-generation of source code.
        # Place any custom global variables above this section.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        m_pcntrc record like stpcntrc.*,  # record holding GL control info
        p_pvendr record
            vend_code like stpvendr.vend_code,
            bus_name like stpvendr.bus_name,
            on_acct_amt like stpvendr.on_acct_amt,
            acct_bal like stpvendr.acct_bal
            end record,
        m_popend record like stpopend.*,  # Record like the header table
        p_popend record   # Record like the header screen
            vend_code like stpopend.vend_code,
            bus_name like stpvendr.bus_name,
            pay_to_code like stpopend.pay_to_code,
            pay_to_name like stppytor.pay_to_name,
            on_acct_amt like stpvendr.on_acct_amt,
            acct_bal like stpvendr.acct_bal,
            inv_no like stpopend.inv_no,
            doc_no like stpopend.doc_no,
            inv_desc like stpopend.inv_desc,
            inv_date like stpopend.inv_date,
            orig_amount like stpopend.orig_amount,
            disc_amt like stpopend.disc_amt,
            balance like stpopend.balance,
            disc_bal like stpopend.disc_bal,
            due_date like stpopend.due_date,
            disc_date like stpopend.disc_date,
            ap_acct_no like stpopend.ap_acct_no,
            ap_department like stpopend.ap_department,
            po_no like stpopend.po_no,
            po_date like stpopend.po_date,
            to_pay_amt like stpopend.to_pay_amt,
            to_take_disc like stpopend.to_take_disc,
            to_pay_date like stpopend.to_pay_date,
            cash_acct_no like stpopend.cash_acct_no,
            cash_department like stpopend.cash_department
        end record,
        q_popend record   # Parallel header record
            row_id integer  # SQL rowid
        end record,

        ###############################################################
        # Library communication area 3.51.00
        ###############################################################
        # Global variables in this section should not be changed.
        # They are used to communicate to the screen library functions,
        # and must be of the same type as defined in the library.
        # Don't remove these comments.  The codegenerator keys on them.
        #
        progid       char(17),   # Program identification
        scr_id       char(7),    # Current screen id
        menu_item    char(10),   # Current menu item running
        scr_funct    char(20),   # Current screen function being run
        sql_filter   char(512),  # Filter portion of SQL statement
        sql_order    char(100),  # Order portion of SQL statement
        input_num    smallint,   # Current input section within screen
        p_cur        smallint,   # Current input array element
        s_cur        smallint,   # Current screen array element
        scr_fld      char(40),   # Current screen field
        nxt_fld      char(40),   # Programmatic next screen field
        prev_data    char(80),   # Data before field entry
        this_data    char(80),   # Data after field entry
        data_changed smallint,   # Has the field data changed?
        hotkey       smallint,   # The hot key that has been pressed
        scratch      char(2047)  # Scratchpad for scribbling on and
                                 # communicating between functions
        # End library communication area
        ###############################################################

end globals
