######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

# Local (static) variables
define
    lookup_prep char(1), # Have the lookups been prepared?
    select_prep char(1), # Has the select statement been prepared?
    exit_level smallint, # 0=input, 1=field
    tab_pressed smallint # (boolean) was the tab key pressed?


######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    # Initialize some variables
    let exit_level = 0
    let tab_pressed = false

    if p_popend.doc_no is null
    then
        let p_popend.doc_no = auto_next("stpcntrc","ap_doc_no")
    end if

    input p_popend.* without defaults from s_popend.*

      # All entry fields must have before and after field processing
      before field vend_code call llh_b_field("stpopend.vend_code")
        goto next_field
      before field pay_to_code call llh_b_field("stpopend.pay_to_code")
        goto next_field
      before field on_acct_amt call llh_b_field("stpvendr.on_acct_amt")
        goto next_field
      before field inv_no call llh_b_field("stpopend.inv_no")
        goto next_field
      before field inv_desc call llh_b_field("stpopend.inv_desc")
        goto next_field
      before field inv_date call llh_b_field("stpopend.inv_date")
        goto next_field
      before field orig_amount call llh_b_field("stpopend.orig_amount")
        goto next_field
      before field disc_amt call llh_b_field("stpopend.disc_amt")
        goto next_field
      before field balance call llh_b_field("stpopend.balance")
        goto next_field
      before field disc_bal call llh_b_field("stpopend.disc_bal")
        goto next_field
      before field due_date call llh_b_field("stpopend.due_date")
        goto next_field
      before field disc_date call llh_b_field("stpopend.disc_date")
        goto next_field
      before field ap_acct_no call llh_b_field("stpopend.ap_acct_no")
        goto next_field
      before field ap_department call llh_b_field("stpopend.ap_department")
        goto next_field
      before field po_no call llh_b_field("stpopend.po_no")
        goto next_field
      before field po_date call llh_b_field("stpopend.po_date")
        goto next_field
      before field to_pay_amt call llh_b_field("stpopend.to_pay_amt")
        goto next_field
      before field to_take_disc call llh_b_field("stpopend.to_take_disc")
        goto next_field
      before field to_pay_date call llh_b_field("stpopend.to_pay_date")
        goto next_field
      before field cash_acct_no call llh_b_field("stpopend.cash_acct_no")
        goto next_field
      before field cash_department call llh_b_field("stpopend.cash_department")
        goto next_field

      after field vend_code call llh_a_field()
        goto next_field
      after field pay_to_code call llh_a_field()
        goto next_field
      after field on_acct_amt call llh_a_field()
        goto next_field
      after field inv_no call llh_a_field()
        goto next_field
      after field inv_desc call llh_a_field()
        goto next_field
      after field inv_date call llh_a_field()
        goto next_field
      after field orig_amount call llh_a_field()
        goto next_field
      after field disc_amt call llh_a_field()
        goto next_field
      after field balance call llh_a_field()
        goto next_field
      after field disc_bal call llh_a_field()
        goto next_field
      after field due_date call llh_a_field()
        goto next_field
      after field disc_date call llh_a_field()
        goto next_field
      after field ap_acct_no call llh_a_field()
        goto next_field
      after field ap_department call llh_a_field()
        goto next_field
      after field po_no call llh_a_field()
        goto next_field
      after field po_date call llh_a_field()
        goto next_field
      after field to_pay_amt call llh_a_field()
        goto next_field
      after field to_take_disc call llh_a_field()
        goto next_field
      after field to_pay_date call llh_a_field()
        goto next_field
      after field cash_acct_no call llh_a_field()
        goto next_field
      after field cash_department call llh_a_field()
        goto next_field

      after input
        label end_input:
        let nxt_fld = null

        # Exit directly upon interrupt
        if int_flag then exit input end if

        # Run the 'after field' logic if necessary
        if exit_level >= 1 then call llh_a_field() end if
        if nxt_fld is not null then goto next_field end if

        # Run the 'after input' logic before exiting input
        call llh_a_input()
        if nxt_fld is not null then goto next_field end if
        exit input

      # Event trapping logic
      on key (control-b) let hotkey = 2  goto event
      on key (control-e) let hotkey = 5  goto event
      on key (control-f) let hotkey = 6  goto event
      on key (control-g) let hotkey = 7  goto event
      on key (control-i) let hotkey = 9  goto event
      on key (control-n) let hotkey = 14 goto event
      on key (control-o) let hotkey = 15 goto event
      on key (control-p) let hotkey = 16 goto event
      on key (control-t) let hotkey = 20 goto event
      on key (control-u) let hotkey = 21 goto event
      on key (control-v) let hotkey = 22 goto event
      on key (control-w) let hotkey = 23 goto event
      on key (control-y) let hotkey = 25 goto event
      on key (control-z) let hotkey = 26 goto event
      on key (f5)  let hotkey = 105 goto event
      on key (f6)  let hotkey = 106 goto event
      on key (f7)  let hotkey = 107 goto event
      on key (f8)  let hotkey = 108 goto event
      on key (f9)  let hotkey = 109 goto event
      on key (f10) let hotkey = 110 goto event
      on key (f11) let hotkey = 111 goto event
      on key (f12) let hotkey = 112 goto event
      on key (f13) let hotkey = 113 goto event
      on key (f14) let hotkey = 114 goto event
      on key (f15) let hotkey = 115 goto event
      on key (f16) let hotkey = 116 goto event
      on key (f34) let hotkey = 134 goto event
      on key (f35) let hotkey = 135 goto event
      on key (f36,interrupt) let hotkey = 136 goto event

      # Local event processing
      label event:
        call hot_local("cancel")
        call hot_key("llh_input")  # Map the key to the event
        call llh_event()

      # Programmatic next field logic
      label next_field:
        case
          when nxt_fld is null  # No need to go through 'case'
          when nxt_fld = "vend_code" next field vend_code
          when nxt_fld = "pay_to_code" next field pay_to_code
          when nxt_fld = "on_acct_amt" next field on_acct_amt
          when nxt_fld = "inv_no" next field inv_no
          when nxt_fld = "inv_desc" next field inv_desc
          when nxt_fld = "inv_date" next field inv_date
          when nxt_fld = "orig_amount" next field orig_amount
          when nxt_fld = "disc_amt" next field disc_amt
          when nxt_fld = "balance" next field balance
          when nxt_fld = "disc_bal" next field disc_bal
          when nxt_fld = "due_date" next field due_date
          when nxt_fld = "disc_date" next field disc_date
          when nxt_fld = "ap_acct_no" next field ap_acct_no
          when nxt_fld = "ap_department" next field ap_department
          when nxt_fld = "po_no" next field po_no
          when nxt_fld = "po_date" next field po_date
          when nxt_fld = "to_pay_amt" next field to_pay_amt
          when nxt_fld = "to_take_disc" next field to_take_disc
          when nxt_fld = "to_pay_date" next field to_pay_date
          when nxt_fld = "cash_acct_no" next field cash_acct_no
          when nxt_fld = "cash_department" next field cash_department
          when nxt_fld = "exit input" goto end_input
        end case
    end input

    # Return -1 if tab was pressed
    if tab_pressed
      then return -1
      else return 0
    end if
end function
# llh_input()

######################################################################
function llh_b_field(field_name)
######################################################################
# This function is called from the input function before every field.
# The 'prv_fld' variable contains the field we came from.
# The 'scr_fld' variable contains the field we're going into.
# Set 'nxt_fld' if you want to skip this field or exit input.
#
    define
        field_name char(40),  # Fieldname passed
        prv_fld char(40)      # The field we were just in

    # Convert field_name from 'tab.col' to 'col'
    let field_name = set_fldtab(field_name)

    # Rearrange field names
    let prv_fld = scr_fld
    let scr_fld = field_name
    let nxt_fld = null

    # Require field level exit
    let exit_level = 1

    # Specify fields only if work needs to be done.
    case
      when scr_fld = "vend_code"
        if menu_item = "update"
        then
            if prv_fld = "pay_to_code"
              then let nxt_fld = "cash_department"
              else let nxt_fld = "pay_to_code" end if
        end if
        let scratch = "zoom"
      when scr_fld = "pay_to_code"
    let scratch = "zoom"
      when scr_fld = "balance"
        if p_popend.balance is null
          then let p_popend.balance = 0 end if
      when scr_fld = "ap_acct_no"
    let scratch = "zoom"
      when scr_fld = "ap_department"
    let scratch = "zoom"
      when scr_fld = "cash_acct_no"
    let scratch = "zoom"
      when scr_fld = "cash_department"
    let scratch = "zoom"
    end case

    # Programmed exit
    if nxt_fld is not null then return end if

    # Setup for lib_before
    let scr_fld = prv_fld
    call lib_before(field_name)

end function
# llh_b_field()

######################################################################
function llh_a_field()
######################################################################
# This function is called after every field.
#
    # Reset nxt_fld
    let nxt_fld = null

    # No more exit levels required
    let exit_level = 0

    # After field logic
    case
      when scr_fld = "vend_code"
        if auto_zoom("vendz","stpvendr","")
          then let p_popend.vend_code = scratch end if
      when scr_fld = "pay_to_code"
        if p_popend.pay_to_code is null
          then let p_popend.pay_to_code = "PAYTO" end if
        let scratch =
          " stppytor.vend_code = \"", p_popend.vend_code, "\""
        if auto_zoom("paytoz","stppytor","(see scratch)")
          then let p_popend.pay_to_code = scratch end if
      when scr_fld = "ap_acct_no"
        if auto_zoom("chrtz","stxchrtr","")
          then let p_popend.ap_acct_no = scratch end if
      when scr_fld = "ap_department"
        if p_popend.ap_department is null
          then let p_popend.ap_department = "000" end if
      when scr_fld = "cash_acct_no"
        if p_popend.cash_department is null
          then let nxt_fld = "cash_department" end if
      when scr_fld = "cash_department"
        if p_popend.cash_department is null and
           p_popend.cash_acct_no is not null
        then
            let p_popend.cash_department = "000"
        end if
    end case

    # Programmed exit
    if nxt_fld is not null then return end if

    # This (among other things) sets data_changed
    call lib_after()

    # After data_changed logic
    if data_changed
    then
        case
          when scr_fld = "vend_code"
            # Perform lookups
            if llh_lookup("vend_name",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "vend_code"
                return
            end if
            if p_popend.vend_code is null
            then
                call fg_err(1) # Vendor code must be entered
                let nxt_fld = "vend_code"
                return
            end if

            if not vend_lock(p_popend.vend_code)  # Attempt to lock stpvendr row
            then
                # Vendor is currently being updated.
                call fg_error("r_menu", "r_update", 4)
                let nxt_fld = "vend_code"
                return
            end if

            call get_vend()

            let p_popend.pay_to_code = null
            let p_popend.pay_to_name = null

            if p_popend.balance is not null
            then
                let p_popend.acct_bal = p_popend.acct_bal +
                    p_popend.balance
            end if
          when scr_fld = "pay_to_code"
            # Perform lookups
            if llh_lookup("pay_code",false) = false
            then
                if p_popend.pay_to_code != "PAYTO"
                then
                    call scr_error("lookup=notfound","stppytor")
                    let nxt_fld = "pay_to_code"
                    return
                else
                    let p_popend.pay_to_name = p_popend.bus_name
                end if
            end if
          when scr_fld = "on_acct_amt"
            let p_popend.on_acct_amt = round("a", p_popend.on_acct_amt)
            if p_popend.on_acct_amt is null
              then let p_popend.on_acct_amt = 0 end if
            let p_popend.acct_bal = p_popend.acct_bal - prev_data +
                p_popend.on_acct_amt
          when scr_fld = "inv_date"
            # make sure g/l is installed
            if table_exist("stgcntrc")
            then
                # check to see if document date is within
                #   current period
                if per_warn(p_popend.inv_date) = true
                then
                   # Warning:  Date Outside Current Period.
                   call fg_err(13)
                end if
            end if
          when scr_fld = "orig_amount"
            let p_popend.orig_amount = round("a", p_popend.orig_amount)
            if p_popend.orig_amount is null
              then let p_popend.orig_amount = 0 end if
            call amount_validate(1)
          when scr_fld = "disc_amt"
            let p_popend.disc_amt = round("a", p_popend.disc_amt)
            if p_popend.disc_amt is null
              then let p_popend.disc_amt = 0 end if
            call amount_validate(2)
          when scr_fld = "balance"
            let p_popend.balance = round("a", p_popend.balance)
            if p_popend.balance is null
              then let p_popend.balance = 0 end if
            let p_popend.acct_bal = p_popend.acct_bal - prev_data +
                p_popend.balance
            call amount_validate(3)
          when scr_fld = "disc_bal"
            let p_popend.disc_bal = round("a", p_popend.disc_bal)
            if p_popend.disc_bal is null
              then let p_popend.disc_bal = 0 end if
            call amount_validate(4)
          when scr_fld = "disc_date"
            if p_popend.to_pay_date is null
            then
                if p_popend.disc_date is null and
                   p_popend.due_date is not null
                then
                    let p_popend.to_pay_date = p_popend.due_date
                end if
                if p_popend.disc_date is not null and
                   p_popend.due_date is null
                then
                    let p_popend.to_pay_date = p_popend.disc_date
                end if
                if p_popend.disc_date is not null and
                   p_popend.due_date is not null
                then
                    let p_popend.to_pay_date = p_popend.disc_date
                end if
                display by name p_popend.to_pay_date
            end if
          when scr_fld = "ap_acct_no"
            # Perform lookups
            if llh_lookup("ap_acct",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "ap_acct_no"
                return
            end if
          when scr_fld = "ap_department"
            # Perform lookups
            if llh_lookup("dept_look2",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "ap_department"
                return
            end if
          when scr_fld = "to_pay_amt"
            let p_popend.to_pay_amt = round("a", p_popend.to_pay_amt)
            if p_popend.to_pay_amt is null
              then let p_popend.to_pay_amt = 0 end if
            call amount_validate(5)
          when scr_fld = "to_take_disc"
            let p_popend.to_take_disc = round("a", p_popend.to_take_disc)
            if p_popend.to_take_disc is null
              then let p_popend.to_take_disc = 0 end if
            call amount_validate(6)
          when scr_fld = "cash_acct_no"
            # Perform lookups
            if llh_lookup("cash_acct",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "cash_acct_no"
                return
            end if
            let p_popend.cash_department = null
            let nxt_fld = "cash_department"
          when scr_fld = "cash_department"
            # Perform lookups
            if llh_lookup("dept_look",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "cash_department"
                return
            end if
            if p_popend.cash_department is not null and
               p_popend.cash_acct_no is not null
            then
                if not valid_cash_acct(
                    p_popend.cash_acct_no, p_popend.cash_department)
                then
                    #cash account/department has not been defined
                    call fg_err(10)
                    let nxt_fld = "cash_acct_no"
                end if
            end if
        end case
    end if

end function
# llh_a_field()

######################################################################
function llh_a_input()
######################################################################
# This function is called whenever the input statement exits
# (except due to an interrupt).  If you don't want the input session
# to end, set the nxt_fld variable to contain the field to be placed
# back into.
#
    if mustfill(p_popend.vend_code,"Vendor Code")
      then let nxt_fld = "vend_code" return end if
    if mustfill(p_popend.pay_to_code,"Pay-To Code")
      then let nxt_fld = "pay_to_code" return end if
    if mustfill(p_popend.cash_acct_no,"Cash Account Number")
      then let nxt_fld = "cash_acct_no" return end if
    if mustfill(p_popend.cash_department,"Cash Department")
      then let nxt_fld = "cash_department" return end if
    if mustfill(p_popend.inv_date,"Invoice Date")
      then let nxt_fld = "inv_date" return end if
    if mustfill(p_popend.due_date,"Invoice Due Date")
      then let nxt_fld = "due_date" return end if
    call amount_validate(7)
    if tab_pressed = false
    then
        call vend_unlock()
    end if

end function
# llh_a_input()

######################################################################
function llh_event()
######################################################################
# This function is called whenever the user presses an event key.
# The event is mapped to the 'scr_funct' variable and processed here.
#
    # Reset tab pressed to false
    let tab_pressed = false
    case
      when scr_funct = "zoom" and infield(pay_to_code)
        let scratch =
          " stppytor.vend_code = \"", p_popend.vend_code, "\""
        if zoom("paytoz","(see scratch)")
        then
            let p_popend.pay_to_code = scratch
            let nxt_fld = "pay_to_code"
        end if
      when scr_funct = "zoom" and infield(vend_code)
        if zoom("vendz","")
        then
            let p_popend.vend_code = scratch
            let nxt_fld = "vend_code"
        end if
      when scr_funct = "zoom" and infield(ap_acct_no)
        if zoom("chrtz","")
        then
            let p_popend.ap_acct_no = scratch
            let nxt_fld = "ap_acct_no"
        end if
      when scr_funct = "zoom" and infield(ap_department)
        let scratch =
          " stxinfor.src_type = \"D\""
        if zoom("deptz","(see scratch)")
        then
            let p_popend.ap_department = scratch
            let nxt_fld = "ap_department"
        end if
      when scr_funct = "zoom" and infield(cash_acct_no)
        let scratch =
          " stxckrgr.acct_no is not null"
        if zoom("ckrgz","(see scratch)")
        then
            let p_popend.cash_acct_no = scratch
            let nxt_fld = "cash_acct_no"
        end if
      when scr_funct = "zoom" and infield(cash_department)
        let scratch =
          " stxckrgr.acct_no is not null"
        if zoom("ckrgdz","(see scratch)")
        then
            let p_popend.cash_department = scratch
            let nxt_fld = "cash_department"
        end if
      when scr_funct = "cancel"
        call vend_unlock()
        if no_cancel()
        then
            let int_flag = false
            let nxt_fld = null
        else
            let int_flag = true
            let nxt_fld = "exit input"
        end if
      when scr_funct = "accept"
        let nxt_fld = "exit input"
      when scr_funct = "tab" or scr_funct = "btab"
        let tab_pressed = true
        let nxt_fld = "exit input"
      when scr_funct = "cancel"
        if no_cancel()
        then
          let int_flag = false
          let nxt_fld = null
        else
          let int_flag = true
          let nxt_fld = "exit input"
        end if
    end case
    let scr_funct = ""

end function
# llh_event()

######################################################################
function llh_setdata()
######################################################################
# This function is called to set the this_data global variable.
#
    case
      when scr_fld = "vend_code"
        call set_data(p_popend.vend_code)
      when scr_fld = "pay_to_code"
        call set_data(p_popend.pay_to_code)
      when scr_fld = "on_acct_amt"
        call set_data(p_popend.on_acct_amt)
      when scr_fld = "inv_no"
        call set_data(p_popend.inv_no)
      when scr_fld = "inv_desc"
        call set_data(p_popend.inv_desc)
      when scr_fld = "inv_date"
        call set_data(p_popend.inv_date)
      when scr_fld = "orig_amount"
        call set_data(p_popend.orig_amount)
      when scr_fld = "disc_amt"
        call set_data(p_popend.disc_amt)
      when scr_fld = "balance"
        call set_data(p_popend.balance)
      when scr_fld = "disc_bal"
        call set_data(p_popend.disc_bal)
      when scr_fld = "due_date"
        call set_data(p_popend.due_date)
      when scr_fld = "disc_date"
        call set_data(p_popend.disc_date)
      when scr_fld = "ap_acct_no"
        call set_data(p_popend.ap_acct_no)
      when scr_fld = "ap_department"
        call set_data(p_popend.ap_department)
      when scr_fld = "po_no"
        call set_data(p_popend.po_no)
      when scr_fld = "po_date"
        call set_data(p_popend.po_date)
      when scr_fld = "to_pay_amt"
        call set_data(p_popend.to_pay_amt)
      when scr_fld = "to_take_disc"
        call set_data(p_popend.to_take_disc)
      when scr_fld = "to_pay_date"
        call set_data(p_popend.to_pay_date)
      when scr_fld = "cash_acct_no"
        call set_data(p_popend.cash_acct_no)
      when scr_fld = "cash_department"
        call set_data(p_popend.cash_department)
    end case
end function
# llh_setdata()

######################################################################
function llh_high()
######################################################################
# This function highlights the specified field name.
# Only input type fields need to be specified.
#
    case
      when scr_fld = "vend_code"
        display by name p_popend.vend_code attribute(reverse)
      when scr_fld = "pay_to_code"
        display by name p_popend.pay_to_code attribute(reverse)
      when scr_fld = "on_acct_amt"
        display by name p_popend.on_acct_amt attribute(reverse)
      when scr_fld = "inv_no"
        display by name p_popend.inv_no attribute(reverse)
      when scr_fld = "inv_desc"
        display by name p_popend.inv_desc attribute(reverse)
      when scr_fld = "inv_date"
        display by name p_popend.inv_date attribute(reverse)
      when scr_fld = "orig_amount"
        display by name p_popend.orig_amount attribute(reverse)
      when scr_fld = "disc_amt"
        display by name p_popend.disc_amt attribute(reverse)
      when scr_fld = "balance"
        display by name p_popend.balance attribute(reverse)
      when scr_fld = "disc_bal"
        display by name p_popend.disc_bal attribute(reverse)
      when scr_fld = "due_date"
        display by name p_popend.due_date attribute(reverse)
      when scr_fld = "disc_date"
        display by name p_popend.disc_date attribute(reverse)
      when scr_fld = "ap_acct_no"
        display by name p_popend.ap_acct_no attribute(reverse)
      when scr_fld = "ap_department"
        display by name p_popend.ap_department attribute(reverse)
      when scr_fld = "po_no"
        display by name p_popend.po_no attribute(reverse)
      when scr_fld = "po_date"
        display by name p_popend.po_date attribute(reverse)
      when scr_fld = "to_pay_amt"
        display by name p_popend.to_pay_amt attribute(reverse)
      when scr_fld = "to_take_disc"
        display by name p_popend.to_take_disc attribute(reverse)
      when scr_fld = "to_pay_date"
        display by name p_popend.to_pay_date attribute(reverse)
      when scr_fld = "cash_acct_no"
        display by name p_popend.cash_acct_no attribute(reverse)
      when scr_fld = "cash_department"
        display by name p_popend.cash_department attribute(reverse)
    end case
end function
# llh_high()

######################################################################
function llh_display()
######################################################################
# This function displays all p_* variables onto the screen
#
    display p_popend.* to s_popend.*  attribute(red)
end function
# llh_display()

######################################################################
function llh_p_prep()
######################################################################
# This function creates the p_* record from the m_* record
#
    let p_popend.vend_code = m_popend.vend_code
    let p_popend.pay_to_code = m_popend.pay_to_code
    let p_popend.inv_no = m_popend.inv_no
    let p_popend.doc_no = m_popend.doc_no
    let p_popend.inv_desc = m_popend.inv_desc
    let p_popend.inv_date = m_popend.inv_date
    let p_popend.orig_amount = m_popend.orig_amount
    let p_popend.disc_amt = m_popend.disc_amt
    let p_popend.balance = m_popend.balance
    let p_popend.disc_bal = m_popend.disc_bal
    let p_popend.due_date = m_popend.due_date
    let p_popend.disc_date = m_popend.disc_date
    let p_popend.ap_acct_no = m_popend.ap_acct_no
    let p_popend.ap_department = m_popend.ap_department
    let p_popend.po_no = m_popend.po_no
    let p_popend.po_date = m_popend.po_date
    let p_popend.to_pay_amt = m_popend.to_pay_amt
    let p_popend.to_take_disc = m_popend.to_take_disc
    let p_popend.to_pay_date = m_popend.to_pay_date
    let p_popend.cash_acct_no = m_popend.cash_acct_no
    let p_popend.cash_department = m_popend.cash_department

    # Perform lookups
    if llh_lookup("vend_name",false) then end if
    if llh_lookup("dept_look",false) then end if
    if llh_lookup("dept_look2",false) then end if
    if llh_lookup("cash_acct",false) then end if
    if llh_lookup("ap_acct",false) then end if

end function
# llh_p_prep()

######################################################################
function llh_m_prep()
######################################################################
# This function creates the m_* record from the p_* record
#
    let m_popend.vend_code = p_popend.vend_code
    let m_popend.pay_to_code = p_popend.pay_to_code
    let m_popend.inv_no = p_popend.inv_no
    let m_popend.doc_no = p_popend.doc_no
    let m_popend.inv_desc = p_popend.inv_desc
    let m_popend.inv_date = p_popend.inv_date
    let m_popend.orig_amount = p_popend.orig_amount
    let m_popend.disc_amt = p_popend.disc_amt
    let m_popend.balance = p_popend.balance
    let m_popend.disc_bal = p_popend.disc_bal
    let m_popend.due_date = p_popend.due_date
    let m_popend.disc_date = p_popend.disc_date
    let m_popend.ap_acct_no = p_popend.ap_acct_no
    let m_popend.ap_department = p_popend.ap_department
    let m_popend.po_no = p_popend.po_no
    let m_popend.po_date = p_popend.po_date
    let m_popend.to_pay_amt = p_popend.to_pay_amt
    let m_popend.to_take_disc = p_popend.to_take_disc
    let m_popend.to_pay_date = p_popend.to_pay_date
    let m_popend.cash_acct_no = p_popend.cash_acct_no
    let m_popend.cash_department = p_popend.cash_department
end function
# llh_m_prep()

######################################################################
function llh_read(ring_rowid)
######################################################################
# This function loads the header p_* record elements.
# It first loads the m_* record from disk, then it
# calls the p_prep routine to fill the p_* record elements.
#
    define
        ring_rowid  integer     # rowid of record to read

    # Prepare the cursor upon first invocation
    if select_prep is null
    then
        let select_prep = "Y"
        let scratch = "select * from stpopend where rowid = ?"
        prepare read_specs from scratch
        declare h_cursor cursor for read_specs
    end if

    # Read the header record
    open h_cursor using ring_rowid
    fetch h_cursor into m_popend.*
    if sqlca.sqlcode != 0 then return end if
    let q_popend.row_id = ring_rowid
    close h_cursor
    call llh_p_prep()
end function
# llh_read()

######################################################################
function llh_delete(ring_rowid)
######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    delete from stpopend
        where rowid = ring_rowid
end function
# llh_delete()

######################################################################
function llh_add()
######################################################################
# This function inserts data into the header table.
#
    define
        new_rowid integer  # Rowid after insert
    # Insert the data
    insert into stpopend values(m_popend.*)
    let new_rowid = sqlca.sqlerrd[6]

    update stpvendr
      set
        on_acct_amt = p_popend.on_acct_amt,
        acct_bal = p_popend.acct_bal
      where stpvendr.vend_code = p_popend.vend_code

    # Reset rowid
    let sqlca.sqlerrd[6] = new_rowid

end function
# llh_add()

######################################################################
function llh_update(ring_rowid)
######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update stpopend set stpopend.* = m_popend.*
      where rowid = ring_rowid
    if sqlca.sqlcode = 0
    then
      update stpvendr
        set
          on_acct_amt = p_popend.on_acct_amt,
          acct_bal = p_popend.acct_bal
        where stpvendr.vend_code = p_popend.vend_code
    end if
end function
# llh_update()


######################################################################
function llh_lookup(tbl_name,mustfind)
# returning false if notfound
######################################################################
# This is the lookup function.  It is passed a table to lookup, and
# based on that, it looks up the key and fills any variables for
# that table.  The lookup function will produce the error if it is
# called with mustfind=true, and a notfound situation exists.
#
    define
        tbl_name char(18),  # Lookup table name
        stat integer,       # Value of sqlca.sqlcode after lookup
        mustfind smallint   # (boolean) produce an error if notfound?

    # Prepare cursors upon first call to this function
    if lookup_prep is null
    then
        let lookup_prep = "Y"
        let scratch = "select bus_name, acct_bal, on_acct_amt ",
          "from stpvendr where ",
          " stpvendr.vend_code = ?"
        prepare str_vend_name from scratch
        declare cur_vend_name cursor for str_vend_name
        let scratch = "select pay_to_name ",
          "from stppytor where ",
          " stppytor.vend_code = ? and",
          " stppytor.pay_to_code = ?"
        prepare str_pay_code from scratch
        declare cur_pay_code cursor for str_pay_code
        let scratch = "select rowid ",
          "from stxinfor where ",
          " stxinfor.src_key = ? and",
          " stxinfor.src_type = \"D\""
        prepare str_dept_look from scratch
        declare cur_dept_look cursor for str_dept_look
        let scratch = "select rowid ",
          "from stxinfor where ",
          " stxinfor.src_key = ? and",
          " stxinfor.src_type = \"D\""
        prepare str_dept_look2 from scratch
        declare cur_dept_look2 cursor for str_dept_look2
        let scratch = "select rowid ",
          "from stxckrgr where ",
          " stxckrgr.acct_no = ?"
        prepare str_cash_acct from scratch
        declare cur_cash_acct cursor for str_cash_acct
        let scratch = "select rowid ",
          "from stxchrtr where ",
          " stxchrtr.acct_no = ?"
        prepare str_ap_acct from scratch
        declare cur_ap_acct cursor for str_ap_acct
    end if

    # Perform the lookup
    case
      when tbl_name = "vend_name"
        open cur_vend_name using p_popend.vend_code
        fetch cur_vend_name into p_popend.bus_name, p_popend.acct_bal,
          p_popend.on_acct_amt
        let stat = sqlca.sqlcode
        close cur_vend_name
      when tbl_name = "pay_code"
        open cur_pay_code using p_popend.vend_code,
          p_popend.pay_to_code
        fetch cur_pay_code into p_popend.pay_to_name
        let stat = sqlca.sqlcode
        close cur_pay_code
      when tbl_name = "dept_look"
        open cur_dept_look using p_popend.cash_department
        fetch cur_dept_look into scratch
        let stat = sqlca.sqlcode
        close cur_dept_look
      when tbl_name = "dept_look2"
        open cur_dept_look2 using p_popend.ap_department
        fetch cur_dept_look2 into scratch
        let stat = sqlca.sqlcode
        close cur_dept_look2
      when tbl_name = "cash_acct"
        open cur_cash_acct using p_popend.cash_acct_no
        fetch cur_cash_acct into scratch
        let stat = sqlca.sqlcode
        close cur_cash_acct
      when tbl_name = "ap_acct"
        open cur_ap_acct using p_popend.ap_acct_no
        fetch cur_ap_acct into scratch
        let stat = sqlca.sqlcode
        close cur_ap_acct
    end case

    # No mustfind is this_data is empty
    if length(this_data) = 0 then let mustfind = false end if

    # Send notfound message to user (if requested)
    let sqlca.sqlcode = stat
    if mustfind and stat = notfound
      then call scr_error("lookup=notfound",tbl_name)
    end if
    let sqlca.sqlcode = 0

    # Return false if lookup failed and empty into fields
    if stat = notfound
    then
        case
          when tbl_name = "vend_name"
            initialize p_popend.bus_name to null
            initialize p_popend.acct_bal to null
            initialize p_popend.on_acct_amt to null
          when tbl_name = "pay_code"
            initialize p_popend.pay_to_name to null
          when tbl_name = "dept_look" or tbl_name = "dept_look2" or
               tbl_name = "cash_acct" or tbl_name = "ap_acct"
            initialize scratch to null
        end case
        return false
    else
        return true
    end if
end function
# llh_lookup()
