######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

######################################################################
main
######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    clear screen
    defer interrupt
    let progid = "ap.i_opend"
    call put_scrlib("version", "3.51.00")
    call put_scrlib("dbname", "standard")

    open window win1 at 2,3 with 22 rows, 76 columns
      attribute (border, blue)
    call init()

    clear window win1
    open window win2 at 2,3 with 22 rows, 76 columns
      attribute (white)
    open form screen1 from "screen"
    call pcontrol() returning m_pcntrc.*
    if m_pcntrc.ap_balanced = "Y"
    then
        open form screen1 from "i_opend2"
    else
        open form screen1 from "i_opend1"
    end if
    display form screen1
    call ring_header()
    exit program (0)
end main

######################################################################
function switchbox(funct)
######################################################################
# This is the switchbox function for version 3.0+ screens.
# It is used to pass flow control to the appropriate screen functions.
#
    define
        funct char(20)   # Function to pass on to the screen

    # Post the current function
    let scr_funct = funct

    # Pass flow control to the appropriate screen
    case
      when scr_id = "paytoz" call paytoz()
      when scr_id = "vendz" call vendz()
      when scr_id = "chrtz" call chrtz()
      when scr_id = "deptz" call deptz()
      when scr_id = "ckrgz" call ckrgz()
      when scr_id = "ckrgdz" call ckrgdz()
      when scr_id = "default" call lib_screen()
      when scr_id = "paytoz" call paytoz()
      when scr_id = "apactvz" call apactvz()
      when scr_id = "apinvcz" call apinvcz()
      when scr_id = "cdactvz" call cdactvz()
      when scr_id = "apiactz" call apiactz()
      otherwise let scratch = "no screen"
    end case

    # Reset scr_funct upon return
    let scr_funct = ""

end function
# switchbox()
