######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

######################################################################
function mlh_init()
# returning the initial find group filter string.
######################################################################
# This function serves two purposes.
# It is called only once upon program invocation, so you may use
# it as a place to run initialization routines.
# It requires a return value of the default select group.
# examples of return values:
#   return "1=1" (select all rows)
#   return "1=0" (select no rows)
#   return "customer_num is not null" (select non-null customer_num's)
#   return "posted = \"N\"" (select only unposted documents)
#
    # Trap fatal errors
    whenever error call error_handler

    return "1=0"
end function
# mlh_init()

######################################################################
function mlh_clear()
######################################################################
#
    initialize p_popend.* to null
    initialize q_popend.* to null
    initialize m_popend.* to null
end function
# mlh_clear

######################################################################
function mlh_construct()
# returning criteria
######################################################################
#
    construct scratch
      on
        stpopend.vend_code, stpopend.pay_to_code, stpopend.inv_no,
        stpopend.doc_no, stpopend.inv_desc, stpopend.inv_date,
        stpopend.orig_amount, stpopend.disc_amt, stpopend.balance,
        stpopend.disc_bal, stpopend.due_date, stpopend.disc_date,
        stpopend.ap_acct_no, stpopend.ap_department, stpopend.po_no,
        stpopend.po_date, stpopend.to_pay_amt, stpopend.to_take_disc,
        stpopend.to_pay_date, stpopend.cash_acct_no,
        stpopend.cash_department
      from
        s_popend.vend_code, s_popend.pay_to_code, s_popend.inv_no,
        s_popend.doc_no, s_popend.inv_desc, s_popend.inv_date,
        s_popend.orig_amount, s_popend.disc_amt, s_popend.balance,
        s_popend.disc_bal, s_popend.due_date, s_popend.disc_date,
        s_popend.ap_acct_no, s_popend.ap_department, s_popend.po_no,
        s_popend.po_date, s_popend.to_pay_amt, s_popend.to_take_disc,
        s_popend.to_pay_date, s_popend.cash_acct_no,
        s_popend.cash_department
    return scratch[1,512]
end function
# mlh_construct

######################################################################
function mlh_cursor()
######################################################################
# This function defines the table, filter, and ordering portions of
# the select statement used to build the FourGen scroller.
#
    call put_vararg("stpopend")
    call put_vararg("")
    call put_vararg("vend_code")
end function
# mlh_cursor()

######################################################################
function mlh_key()
# returning tablename, key_field [,key_field]... in (vararg) scratch
######################################################################
# This function returns (in vararg scratch) the name of the main table
# for this screen and the field name(s) and their data that build
# the unique key into this table.
# This is used to determine the unique key for additional fields,
# notes, and other items that may key off this document.  The key
# field(s) must not exceed 30 characters total.
# The first vararg call is the table name.  The following varargs are
# called in pairs.  The first of the pair is the column name, and
# the second in the pair is the column data.
#
    call put_vararg("stpopend")
    call put_vararg("vend_code")
    call put_vararg(m_popend.vend_code)
end function
# mlh_key()
