########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/i_opend.4gs/screen.trg  1.10  Delta: 2/13/91
########################################################################
defaults

    define  
        m_pcntrc record like stpcntrc.*,  # record holding GL control info
        p_pvendr record
            vend_code like stpvendr.vend_code,
            bus_name like stpvendr.bus_name,
            on_acct_amt like stpvendr.on_acct_amt,
            acct_bal like stpvendr.acct_bal
            end record;

    libraries
        ../../all.4gm/lib.a;

    do_not_generate
        llh_lookup;

    switchbox_items
      paytoz paytoz()   # pay to zoom
      apactvz apactvz() # ap activity zoom
      apinvcz apinvcz() # ap invoice detail
      cdactvz cdactvz() # cash disbursement detail
      apiactz apiactz() # ap invoice activity detail;

    after_init
        call pcontrol() returning m_pcntrc.*
        if m_pcntrc.ap_balanced = "Y"
        then
            open form screen1 from "i_opend2"
        else
            open form screen1 from "i_opend1"
        end if;


input 1
    on_disk_add
          update stpvendr
            set
              on_acct_amt = p_popend.on_acct_amt,
              acct_bal = p_popend.acct_bal
            where stpvendr.vend_code = p_popend.vend_code ;

    on_disk_update
        if sqlca.sqlcode = 0
        then
          update stpvendr
            set
              on_acct_amt = p_popend.on_acct_amt,
              acct_bal = p_popend.acct_bal
            where stpvendr.vend_code = p_popend.vend_code 
        end if ;

    before_input
        if p_popend.doc_no is null
        then
            let p_popend.doc_no = auto_next("stpcntrc","ap_doc_no")
        end if;

    before_field vend_code
        if menu_item = "update"
        then 
            if prv_fld = "pay_to_code"
              then let nxt_fld = "cash_department" 
              else let nxt_fld = "pay_to_code" end if
        end if;

    after_field ap_department
        if p_popend.ap_department is null
          then let p_popend.ap_department = "000" end if;

    after_change_in vend_code
        if p_popend.vend_code is null
        then
            call fg_err(1) # Vendor code must be entered
            let nxt_fld = "vend_code"
            return
        end if

        if not vend_lock(p_popend.vend_code)  # Attempt to lock stpvendr row
        then
            # Vendor is currently being updated.
            call fg_error("r_menu", "r_update", 4) 
            let nxt_fld = "vend_code"
            return
        end if

        call get_vend()

        let p_popend.pay_to_code = null
        let p_popend.pay_to_name = null

        if p_popend.balance is not null
        then
            let p_popend.acct_bal = p_popend.acct_bal +
                p_popend.balance
        end if;

    after_field pay_to_code
        if p_popend.pay_to_code is null
          then let p_popend.pay_to_code = "PAYTO" end if;
        
    after_change_in pay_to_code
        # Perform lookups
        if llh_lookup("pay_code",false) = false
        then
            if p_popend.pay_to_code != "PAYTO"
            then
                call scr_error("lookup=notfound","stppytor")
                let nxt_fld = "pay_to_code"
                return
            else
                let p_popend.pay_to_name = p_popend.bus_name
            end if
        end if;

    after_change_in inv_date
        # make sure g/l is installed
        if table_exist("stgcntrc") 
        then
            # check to see if document date is within
            #   current period
            if per_warn(p_popend.inv_date) = true
            then
               # Warning:  Date Outside Current Period.
               call fg_err(13)
            end if
        end if;

    before_field on_acct_amount
        if p_popend.on_acct_amt is null
          then let p_popend.on_acct_amt = 0 end if
        if p_popend.acct_bal is null
          then let p_popend.acct_bal = 0 end if;
        
    after_change_in on_acct_amt
        let p_popend.on_acct_amt = round("a", p_popend.on_acct_amt)
        if p_popend.on_acct_amt is null
          then let p_popend.on_acct_amt = 0 end if
        let p_popend.acct_bal = p_popend.acct_bal - prev_data +
            p_popend.on_acct_amt;

    after_change_in orig_amount
        let p_popend.orig_amount = round("a", p_popend.orig_amount)
        if p_popend.orig_amount is null 
          then let p_popend.orig_amount = 0 end if
        call amount_validate(1);

    after_change_in disc_amt
        let p_popend.disc_amt = round("a", p_popend.disc_amt)
        if p_popend.disc_amt is null 
          then let p_popend.disc_amt = 0 end if
        call amount_validate(2);

    before_field balance
        if p_popend.balance is null
          then let p_popend.balance = 0 end if;

    after_change_in balance
        let p_popend.balance = round("a", p_popend.balance)
        if p_popend.balance is null 
          then let p_popend.balance = 0 end if
        let p_popend.acct_bal = p_popend.acct_bal - prev_data +
            p_popend.balance
        call amount_validate(3);
 
    after_change_in disc_bal
        let p_popend.disc_bal = round("a", p_popend.disc_bal)
        if p_popend.disc_bal is null 
          then let p_popend.disc_bal = 0 end if
        call amount_validate(4);

    after_change_in to_pay_amt
        let p_popend.to_pay_amt = round("a", p_popend.to_pay_amt)
        if p_popend.to_pay_amt is null 
          then let p_popend.to_pay_amt = 0 end if
        call amount_validate(5);

    after_change_in to_take_disc
        let p_popend.to_take_disc = round("a", p_popend.to_take_disc)
        if p_popend.to_take_disc is null 
          then let p_popend.to_take_disc = 0 end if
        call amount_validate(6);

    after_change_in disc_date
        if p_popend.to_pay_date is null
        then
            if p_popend.disc_date is null and
               p_popend.due_date is not null
            then
                let p_popend.to_pay_date = p_popend.due_date
            end if
            if p_popend.disc_date is not null and
               p_popend.due_date is null
            then
                let p_popend.to_pay_date = p_popend.disc_date
            end if
            if p_popend.disc_date is not null and
               p_popend.due_date is not null
            then
                let p_popend.to_pay_date = p_popend.disc_date
            end if
            display by name p_popend.to_pay_date
        end if;

    after_field cash_acct_no
        if p_popend.cash_department is null 
          then let nxt_fld = "cash_department" end if ;

    after_change_in cash_acct_no
        let p_popend.cash_department = null
        let nxt_fld = "cash_department" ;

    after_field cash_department
        if p_popend.cash_department is null and
           p_popend.cash_acct_no is not null
        then
            let p_popend.cash_department = "000"
        end if ;

    after_change_in cash_department
        if p_popend.cash_department is not null and 
           p_popend.cash_acct_no is not null
        then
            if not valid_cash_acct(
                p_popend.cash_acct_no, p_popend.cash_department)
            then
                #cash account/department has not been defined
                call fg_err(10) 
                let nxt_fld = "cash_acct_no"
            end if
        end if;

    after_input
        if mustfill(p_popend.vend_code,"Vendor Code")
          then let nxt_fld = "vend_code" return end if
        if mustfill(p_popend.pay_to_code,"Pay-To Code")
          then let nxt_fld = "pay_to_code" return end if
        if mustfill(p_popend.cash_acct_no,"Cash Account Number")
          then let nxt_fld = "cash_acct_no" return end if
        if mustfill(p_popend.cash_department,"Cash Department")
          then let nxt_fld = "cash_department" return end if
        if mustfill(p_popend.inv_date,"Invoice Date")
          then let nxt_fld = "inv_date" return end if
        if mustfill(p_popend.due_date,"Invoice Due Date")
          then let nxt_fld = "due_date" return end if
        call amount_validate(7)
        if tab_pressed = false
        then
            call vend_unlock()
        end if;

    on_event cancel
      call vend_unlock()
      if no_cancel()
      then
          let int_flag = false
          let nxt_fld = null
      else
          let int_flag = true
          let nxt_fld = "exit input"
      end if;
        
    at_eof
######################################################################
function llh_lookup(tbl_name,mustfind)
# returning false if notfound
######################################################################
# This is the lookup function.  It is passed a table to lookup, and
# based on that, it looks up the key and fills any variables for
# that table.  The lookup function will produce the error if it is
# called with mustfind=true, and a notfound situation exists.
#
    define
        tbl_name char(18),  # Lookup table name
        stat integer,       # Value of sqlca.sqlcode after lookup
        mustfind smallint   # (boolean) produce an error if notfound?

    # Prepare cursors upon first call to this function
    if lookup_prep is null
    then
        let lookup_prep = "Y"
        let scratch = "select bus_name, acct_bal, on_acct_amt ",
          "from stpvendr where ",
          " stpvendr.vend_code = ?"
        prepare str_vend_name from scratch
        declare cur_vend_name cursor for str_vend_name
        let scratch = "select pay_to_name ",
          "from stppytor where ",
          " stppytor.vend_code = ? and",
          " stppytor.pay_to_code = ?"
        prepare str_pay_code from scratch
        declare cur_pay_code cursor for str_pay_code
        let scratch = "select rowid ",
          "from stxinfor where ",
          " stxinfor.src_key = ? and",
          " stxinfor.src_type = \"D\""
        prepare str_dept_look from scratch
        declare cur_dept_look cursor for str_dept_look
        let scratch = "select rowid ",
          "from stxinfor where ",
          " stxinfor.src_key = ? and",
          " stxinfor.src_type = \"D\""
        prepare str_dept_look2 from scratch
        declare cur_dept_look2 cursor for str_dept_look2
        let scratch = "select rowid ",
          "from stxckrgr where ",
          " stxckrgr.acct_no = ?"
        prepare str_cash_acct from scratch
        declare cur_cash_acct cursor for str_cash_acct
        let scratch = "select rowid ",
          "from stxchrtr where ",
          " stxchrtr.acct_no = ?"
        prepare str_ap_acct from scratch
        declare cur_ap_acct cursor for str_ap_acct
    end if

    # Perform the lookup
    case
      when tbl_name = "vend_name"
        open cur_vend_name using p_popend.vend_code
        fetch cur_vend_name into p_popend.bus_name, p_popend.acct_bal,
          p_popend.on_acct_amt
        let stat = sqlca.sqlcode
        close cur_vend_name
      when tbl_name = "pay_code"
        open cur_pay_code using p_popend.vend_code,
          p_popend.pay_to_code
        fetch cur_pay_code into p_popend.pay_to_name
        let stat = sqlca.sqlcode
        close cur_pay_code
      when tbl_name = "dept_look"
        open cur_dept_look using p_popend.cash_department
        fetch cur_dept_look into scratch
        let stat = sqlca.sqlcode
        close cur_dept_look
      when tbl_name = "dept_look2"
        open cur_dept_look2 using p_popend.ap_department
        fetch cur_dept_look2 into scratch
        let stat = sqlca.sqlcode
        close cur_dept_look2
      when tbl_name = "cash_acct"
        open cur_cash_acct using p_popend.cash_acct_no
        fetch cur_cash_acct into scratch
        let stat = sqlca.sqlcode
        close cur_cash_acct
      when tbl_name = "ap_acct"
        open cur_ap_acct using p_popend.ap_acct_no
        fetch cur_ap_acct into scratch
        let stat = sqlca.sqlcode
        close cur_ap_acct
    end case

    # No mustfind is this_data is empty
    if length(this_data) = 0 then let mustfind = false end if

    # Send notfound message to user (if requested)
    let sqlca.sqlcode = stat
    if mustfind and stat = notfound
      then call scr_error("lookup=notfound",tbl_name)
    end if
    let sqlca.sqlcode = 0

    # Return false if lookup failed and empty into fields
    if stat = notfound
    then
        case
          when tbl_name = "vend_name"
            initialize p_popend.bus_name to null
            initialize p_popend.acct_bal to null
            initialize p_popend.on_acct_amt to null
          when tbl_name = "pay_code"
            initialize p_popend.pay_to_name to null
          when tbl_name = "dept_look" or tbl_name = "dept_look2" or 
               tbl_name = "cash_acct" or tbl_name = "ap_acct"
            initialize scratch to null
        end case
        return false
    else
        return true
    end if
end function
# llh_lookup();
