########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_1099.4gs/midlevel.4gl  1.2  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    let ct.sel_join = "1=1"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter = "1=1"
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = ""
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from stp1099r ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "stp1099r.vend_code, ",
            "stp1099r.total_amt, ",
            "stp1099r.cat_1_amt, ",
            "stp1099r.cat_2_amt, ",
            "stp1099r.cat_3_amt, ",
            "stp1099r.cat_4_amt, ",
            "stp1099r.cat_5_amt, ",
            "stp1099r.cat_6_amt, ",
            "stp1099r.cat_7_amt, ",
            "stp1099r.cat_8_amt, ",
            "stp1099r.cat_9_amt, ",
            "stp1099r.cat_10_amt ",
        "from stp1099r ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.vend_code = curs_next.vend_code
    let curs.total_amt = curs_next.total_amt
    let curs.cat_1_amt = curs_next.cat_1_amt
    let curs.cat_2_amt = curs_next.cat_2_amt
    let curs.cat_3_amt = curs_next.cat_3_amt
    let curs.cat_4_amt = curs_next.cat_4_amt
    let curs.cat_5_amt = curs_next.cat_5_amt
    let curs.cat_6_amt = curs_next.cat_6_amt
    let curs.cat_7_amt = curs_next.cat_7_amt
    let curs.cat_8_amt = curs_next.cat_8_amt
    let curs.cat_9_amt = curs_next.cat_9_amt
    let curs.cat_10_amt = curs_next.cat_10_amt
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Vendor 1099 Information"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = 10
    let rpt.co_name = al_compn()
end function
# ml_defaults()

