########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_1099.4gs/report.4gl  1.4  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            title_heading char(35),
            co_name char(30),
            vend_code like stp1099r.vend_code,
            vend_name char(25),
            total_amt like stp1099r.total_amt,
            cat_1_amt like stp1099r.cat_1_amt,
            cat_2_amt like stp1099r.cat_2_amt,
            cat_3_amt like stp1099r.cat_3_amt,
            cat_4_amt like stp1099r.cat_4_amt,
            cat_5_amt like stp1099r.cat_5_amt,
            cat_6_amt like stp1099r.cat_6_amt,
            cat_7_amt like stp1099r.cat_7_amt,
            cat_8_amt like stp1099r.cat_8_amt,
            cat_9_amt like stp1099r.cat_9_amt,
            cat_10_amt like stp1099r.cat_10_amt
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = rpt.title_heading
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
                column   3, "Vendor",
                column  19, "Name",
                column  48, "Total Amount"
            print
                column   1, "========================================",
                column  41, "========================================"

        on every row
            need 11 lines
            print
                column   3, rpt.vend_code,
                column  14, rpt.vend_name,
                column  46, rpt.total_amt using "(((,(((,(((.&&)"
            print
            print
                column  18, "-------------------- 1099 Categories ---",
                column  58, "-------------------"
            print
            print
                column  18, "Category 1: ",
                column  30, rpt.cat_1_amt using "(((,(((,(((.&&)",
                column  48, "Category",
                column  58, "2: ",
                column  61, rpt.cat_2_amt using "(((,(((,(((.&&)"
            print
                column  18, "Category 3: ",
                column  30, rpt.cat_3_amt using "(((,(((,(((.&&)",
                column  48, "Category",
                column  58, "4: ",
                column  61, rpt.cat_4_amt using "(((,(((,(((.&&)"
            print
                column  18, "Category 5: ",
                column  30, rpt.cat_5_amt using "(((,(((,(((.&&)",
                column  48, "Category",
                column  58, "6: ",
                column  61, rpt.cat_6_amt using "(((,(((,(((.&&)"
            print
                column  18, "Category 7: ",
                column  30, rpt.cat_7_amt using "(((,(((,(((.&&)",
                column  48, "Category",
                column  58, "8: ",
                column  61, rpt.cat_8_amt using "(((,(((,(((.&&)"
            print
                column  18, "Category 9: ",
                column  30, rpt.cat_9_amt using "(((,(((,(((.&&)",
                column  48, "Category 10: ",
                column  61, rpt.cat_10_amt using "(((,(((,(((.&&)"
            print
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

end report
# report1()

