########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_agedtl.4gs/globals.4gl  1.10  Delta: 2/4/91
########################################################################

database standard

globals
    define
        is_aging_rpt smallint,      # aging or cash requirement
        is_detail_rpt smallint,     # detail or summary report
        progid   char(17),          # program identification
        report_sort char(19),       # sort by vendor code or name
        m_pcntrc record like stpcntrc.*,
        p_cur_row smallint,
        rpt record                  # record for the report
            report_org char(7),     # summary or detail
            title_heading char(40),          
            order_group char(37),   # sort by vendor code or name
            balance like stpopend.balance,
            co_name like stxcntrc.co_name,
            aging_date date,
            date_heading char(9),
            per1_heading like stpcntrc.age_dsc1,
            per2_heading like stpcntrc.age_dsc2,
            per3_heading like stpcntrc.age_dsc3,
            per4_heading like stpcntrc.age_dsc4,
            vend_code like stpvendr.vend_code,
            bus_name like stpvendr.bus_name,
            po_no like stpopend.po_no,        # not currently used
            heading char(10),
            inv_no like stpopend.inv_no,      
            inv_doc_no like stpactvd.inv_doc_no,    
            out_date date,
            per1 like stpopend.balance,
            per2 like stpopend.balance,
            per3 like stpopend.balance,
            per4 like stpopend.balance,
            sub_total like stpopend.balance,
            sub_per1 like stpopend.balance,
            sub_per2 like stpopend.balance,
            sub_per3 like stpopend.balance,
            sub_per4 like stpopend.balance,
            tot_total like stpopend.balance,
            tot_per1 like stpopend.balance,
            tot_per2 like stpopend.balance,
            tot_per3 like stpopend.balance,
            tot_per4 like stpopend.balance
        end record,
        curs record                 # record like the cursor
            vend_code like stpvendr.vend_code,
            inv_doc_no like stpactvd.inv_doc_no,
            balance like stpopend.balance,
            date_used like stpopend.due_date,
            bus_name like stpvendr.bus_name
        end record,
        curs_next record            # next row of cursor
            vend_code like stpvendr.vend_code,
            inv_doc_no like stpactvd.inv_doc_no,
            balance like stpopend.balance,
            date_used like stpopend.due_date,
            bus_name like stpvendr.bus_name
        end record,
        ct record                   # control record (don't change)
            prcname      char(35),  # process name (message on upper left)
            rtmargn      char(35),  # message on upper right margin
            prc_only     char(1),   # process only? (no report) "y" or "n"
            allow_int    char(1),   # allow interrupts? "y" or "n"
            quiet        smallint,  # display every "quiet" rows
            destin       char(150), # "screen","printer","pipe", or "filename"
            sel_join     char(200), # join portion of selection stmt
            sel_filter   char(200), # filter portion of selection stmt
            sel_order    char(200), # order by clause for above
            sel_stmt     char(1024),# select statement for report cursor
            num_rows     integer,   # number of rows in the cursor to process
            cur_row      integer    # current row being processed
        end record
end globals
