########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_agedtl.4gs/midlevel.4gl  1.13  Delta: 2/8/91
########################################################################

globals "globals.4gl"

define
    sel_join char(300)  # join statement to replace ct.sel_join

#######################################################################
function ml_join()
#######################################################################
#
    # Trap fatal errors
    whenever error call error_handler
    let sel_join =
        "stxtranr.orig_journal = stpactvd.orig_journal and ",
        "stxtranr.doc_no = stpactvd.doc_no and ",
        "stpactvd.inv_doc_no = stpopend.doc_no and ",
        "stxtranr.ref_code = stpvendr.vend_code and ",
        "stpvendr.acct_bal != 0 and ",
        "stpactvd.act_type != \"D\""
    return
end function
# ml_join()
#######################################################################
function ml_filter()
#######################################################################
#
    define
        quote char(1),
        yes_no char(1)
    open window prmt_win at 10,10
      with 3 rows, 60 columns attribute(border, prompt line first)
      call menu_line()
      if m_pcntrc.age_datetype = "I"
      then
        display "Enter [N] to use due date or [ENTER] to use invoice date." 
          at 2,2
        prompt " Use Invoice Date for aging? " for char yes_no
      else
        display "Enter [N] to use invoice date or [ENTER] to use due date." 
          at 2,2
        prompt " Use Due Date for aging? " for char yes_no
      end if
    close window prmt_win
    if int_flag != 0 then exit program(0) end if
    if m_pcntrc.age_datetype = "I" and upshift(yes_no) = "N"
    then 
        let m_pcntrc.age_datetype = "D"
    else
        if m_pcntrc.age_datetype = "D" and upshift(yes_no) = "N"
        then 
            let m_pcntrc.age_datetype = "I"
        end if 
    end if
    if m_pcntrc.age_datetype = "I"
    then
        let rpt.date_heading = "Inv Date"
    else
        let rpt.date_heading = "Due Date"
    end if
    call ap_aged() returning rpt.aging_date
    call sel_vend() returning ct.sel_filter
    let quote = "\""
    let ct.sel_filter = ct.sel_filter clipped,
        " and stxtranr.doc_date <= ", quote, rpt.aging_date, quote
    return
end function
# ml_filter()
#######################################################################
function ml_order()
#######################################################################
#
    if m_pcntrc.age_datetype = "D"
    then
        let ct.sel_order = report_sort clipped, ", due_date, ", 
                           "inv_doc_no "
    else
        let ct.sel_order = report_sort clipped, ", inv_date, ", 
                           "inv_doc_no "
    end if
    return
end function
# ml_order()
#######################################################################
function ml_getcount()
#######################################################################
#
    if m_pcntrc.age_datetype = "D"    # report is based on due date
    then
        let ct.sel_stmt =
            "select ",
                "stpvendr.vend_code, ",
                "stpactvd.inv_doc_no, ",
                "sum(stpactvd.amount) sum_amount, ",
                "stpopend.due_date, ",
                "stpvendr.bus_name ",
            "from stxtranr, stpactvd, stpvendr, outer stpopend ",
            "where (", sel_join clipped,
            ") and (", ct.sel_filter clipped, ") ",
            "group by stpvendr.vend_code, stpvendr.bus_name, ",
            "stpactvd.inv_doc_no, stpopend.due_date ",
            "having sum(stpactvd.amount) != 0 ",
            "into temp temp_table "
    else                          # report is based on invoice date
        let ct.sel_stmt =
            "select ",
                "stpvendr.vend_code, ",
                "stpactvd.inv_doc_no, ",
                "sum(stpactvd.amount) sum_amount, ",
                "stpopend.inv_date, ",
                "stpvendr.bus_name ",
            "from stxtranr, stpactvd, stpvendr, outer stpopend ",
            "where (", sel_join clipped,
            ") and (", ct.sel_filter clipped, ") ",
            "group by stpvendr.vend_code, stpvendr.bus_name, ",
            "stpactvd.inv_doc_no, stpopend.inv_date ",
            "having sum(stpactvd.amount) != 0 ",
            "into temp temp_table "
    end if
    if is_4_0()
    then
        let ct.sel_stmt = ct.sel_stmt clipped, " with no log"
    end if
    prepare get_count from ct.sel_stmt
    execute get_count
    let ct.num_rows = sqlca.sqlerrd[3]
    return
end function
# ml_getcount()
#######################################################################
function ml_define_cur()
#######################################################################
#
    if ct.sel_order is not null
    then
        let ct.sel_stmt =
            "create cluster index temp_index on temp_table (",
            ct.sel_order clipped, ")"
        prepare get_curs from ct.sel_stmt
        execute get_curs
    end if
    select min(rowid) into p_cur_row from temp_table
    return
end function
# ml_define_cur()
#######################################################################
function ml_fetch()
#######################################################################
#
    while true
        if m_pcntrc.age_datetype = "D"
        then
            select
                vend_code, 
                inv_doc_no,
                sum_amount,
                due_date, 
                bus_name 
            into curs_next.*
            from temp_table where rowid = p_cur_row
    
        else   # m_pcntrc.age_datetype = "I"
            select
                vend_code, 
                inv_doc_no,
                sum_amount,
                inv_date, 
                bus_name 
            into curs_next.*
            from temp_table where rowid = p_cur_row
        end if
        if status = 0 then exit while end if
        select min(rowid) into p_cur_row from temp_table
        where rowid >= p_cur_row
    end while
    let p_cur_row = p_cur_row + 1
    return
end function
# ml_fetch()
#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()
#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()
#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.vend_code = curs_next.vend_code
    let curs.inv_doc_no = curs_next.inv_doc_no
    let curs.balance = curs_next.balance
    let curs.date_used = curs_next.date_used
    let curs.bus_name = curs_next.bus_name
end function
# ml_curs_prep()
#######################################################################
function ml_before_break()
#######################################################################
# This function calls before_group() when vendor-level and/or
# inv_doc_no-level control breaks occur. 
#
    define
        sort_cur char(37),      # stores vend_code or bus_name
        sort_cur_next char(37), # stores vend_code or bus_name
        no_break    smallint    # set to false if control break occurs
    let no_break = true
    case
        when report_sort = "vend_code"
             let sort_cur = curs.vend_code
             let sort_cur_next = curs_next.vend_code
        otherwise
             let sort_cur = curs.bus_name,",",curs.vend_code
             let sort_cur_next = curs_next.bus_name,",",curs_next.vend_code
    end case
    # determine if a vendor-level break has occurred
    if no_break and curs.vend_code = curs_next.vend_code
    then else
        # if there has been a change in vendor code
        # transfer curs_next data to curs record 
        if no_break then call ml_curs_prep() end if
        call before_group(report_sort)
        let no_break = false
    end if
    # if there's been no vendor-level break
    # determine if an inv_doc_no-level break has occurred
    if no_break and curs.inv_doc_no = curs_next.inv_doc_no
    then else
        # if there has been a change in inv_doc_no
        # transfer curs_next data to curs record 
        if no_break then call ml_curs_prep() end if
        call before_group("inv_doc_no")
        let no_break = false
    end if
end function
# ml_before_break()
#######################################################################
function ml_after_break()
#######################################################################
# This function calls after_group() when when vendor-level and/or
# inv_doc_no-level control breaks occur.
#
    define
        sort_cur char(37),      # stores cust_code or bus_name
        sort_cur_next char(37), # stores cust_code or bus_name
        no_break smallint       # set to true if no prev. break
    let no_break = true
    case
        when report_sort = "vend_code"
             let sort_cur = curs.vend_code
             let sort_cur_next = curs_next.vend_code
        otherwise
             let sort_cur = curs.bus_name,",",curs.vend_code
             let sort_cur_next = curs_next.bus_name,",",curs_next.vend_code
    end case
    # check for vendor-level control break
    if no_break and curs.vend_code = curs_next.vend_code
    then else
        # if there's been a change in vendor
        # print final detail line for current vendor
        call after_group("inv_doc_no")  
        # print the totals for the current vendor
        call after_group(report_sort)
        let no_break = false
    end if
    # check for inv_doc_no-level control break
    if no_break       # if no previous break has been processed
    then
        if curs.inv_doc_no = curs_next.inv_doc_no
        then else
            # if there's been a change in inv_doc_no
            call after_group("inv_doc_no")  
            let no_break = false
        end if
    end if
end function
# ml_after_break()
#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()
#######################################################################
function ml_defaults()
#######################################################################
# This function sets the ct.* record values, and determines whether 
# the detail or summary version of the report is being run.
#
    define
        n        smallint,   # counter 
	    scratch  char(8),    # stores info for report heading
        scratch1 char(22)    # stores info for report heading

    # initialize type of report (Cash Requirements or Vendor Aging)
    let is_aging_rpt = true

    # initalize report sort (vendor code or business name/vendor code)
    let report_sort = "vend_code"
    let scratch = " By Code"

    # initialize report organization (summary or detail)
    let rpt.report_org = "detail"
    let scratch1 = "Detail"
    let is_detail_rpt = true

    # interpret the arguments passed to the program
    for n = 1 to num_args()
        if arg_val(n) = "-cash"   # vendor cash requirement report
        then
            let is_aging_rpt = false
        end if
        if arg_val(n) = "-vc"
        then
            let report_sort = "vend_code"
            let scratch = " By Code"
        end if
        if arg_val(n) = "-n"
        then
            let report_sort = "bus_name, vend_code"
            let scratch = " By Name"
        end if
        if arg_val(n) = "-s"
        then
            let rpt.report_org = "summary"
            let scratch1 = "Summary"
            let is_detail_rpt = false
        end if
        if arg_val(n) = "-dt"
        then
            let rpt.report_org = "detail"
            let scratch1 = "Detail"
            let is_detail_rpt = true
        end if
    end for
    if is_aging_rpt 
    then
        let rpt.title_heading = "Vendor Aging ", scratch1 clipped, 
                                scratch clipped
    else
        let rpt.title_heading = "Vendor Cash Requirement ", scratch1 clipped,
                                 scratch clipped
    end if
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "10"
    let rpt.co_name = al_compn()
end function
# ml_defaults()
