########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_agedtl.4gs/report.4gl  1.11  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            report_org char(7),     # summary or detail
            title_heading char(40),                 
            order_group char(37),   # sort by vendor code or name
            balance like stpopend.balance,
            co_name like stxcntrc.co_name,
            aging_date date,
            date_heading char(9),
            per1_heading like stpcntrc.age_dsc1,
            per2_heading like stpcntrc.age_dsc2,
            per3_heading like stpcntrc.age_dsc3,
            per4_heading like stpcntrc.age_dsc4,
            vend_code like stpvendr.vend_code,
            bus_name like stpvendr.bus_name,
            po_no like stpopend.po_no,              # not currently used
            heading char(10),
            inv_no like stpopend.inv_no,
            inv_doc_no like stpactvd.inv_doc_no,    
            out_date date,
            per1 like stpopend.balance,
            per2 like stpopend.balance,
            per3 like stpopend.balance,
            per4 like stpopend.balance,
            sub_total like stpopend.balance,
            sub_per1 like stpopend.balance,
            sub_per2 like stpopend.balance,
            sub_per3 like stpopend.balance,
            sub_per4 like stpopend.balance,
            tot_total like stpopend.balance,
            tot_per1 like stpopend.balance,
            tot_per2 like stpopend.balance,
            tot_per3 like stpopend.balance,
            tot_per4 like stpopend.balance
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number
    output
        left margin     0
        right margin    80
    order external by rpt.order_group, rpt.out_date, rpt.inv_doc_no
    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = rpt.title_heading
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "Age by: ", rpt.date_heading,
                column  29, "Aging Date: ",
                column  41, rpt.aging_date using "mm/dd/yy"
            print
            if is_detail_rpt
            then
                print
                    column   1, "Invoice ",
                    column  12, rpt.date_heading,
                    column  20, rpt.per1_heading,
                    column  35, rpt.per2_heading,
                    column  50, rpt.per3_heading,
                    column  65, rpt.per4_heading
            else
                print
                    column  20, rpt.per1_heading,
                    column  35, rpt.per2_heading,
                    column  50, rpt.per3_heading,
                    column  65, rpt.per4_heading
            end if
            print
                column   1, "========================================",
                column  41, "========================================"
        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, rpt.title_heading
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
        before group of rpt.order_group
            need 4 lines
            print
                column   1, rpt.vend_code clipped,
                            " ", "-" clipped,
                            " ", rpt.bus_name
        after group of rpt.inv_doc_no
        if rpt.report_org = "detail"
            then
                if
                   rpt.inv_no is not null
                or rpt.out_date is not null
                or rpt.per1 is not null
                or rpt.per2 is not null
                or rpt.per3 is not null
                or rpt.per4 is not null
                then
                    print
                        column   1, rpt.inv_no,
                        column  12, rpt.out_date using "mm/dd/yy",
                        column  22, rpt.per1 using "---,---,---.&&",
                        column  37, rpt.per2 using "---,---,---.&&",
                        column  52, rpt.per3 using "---,---,---.&&",
                        column  67, rpt.per4 using "---,---,---.&&"
                end if
        end if
        after group of rpt.order_group
            need 3 lines
            print
                column  23, "-------------",
                column  38, "-------------",
                column  53, "-------------",
                column  68, "-------------"
            print
                column   1, "Total ",
                column   7, rpt.sub_total using "---,---,---.&&",
                column  22, rpt.sub_per1 using "---,---,---.&&",
                column  37, rpt.sub_per2 using "---,---,---.&&",
                column  52, rpt.sub_per3 using "---,---,---.&&",
                column  67, rpt.sub_per4 using "---,---,---.&&"
            print
        on last row
            need 7 lines
            print
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"
            print
                column   1, "Aging Totals:"
            print
            print
                column  16, "Total",
                column  21, rpt.per1_heading,
                column  36, rpt.per2_heading,
                column  51, rpt.per3_heading,
                column  66, rpt.per4_heading
            print
                column   8, "-------------",
                column  23, "-------------",
                column  38, "-------------",
                column  53, "-------------",
                column  68, "-------------"
            print
                column   7, rpt.tot_total using "---,---,---.&&",
                column  22, rpt.tot_per1 using "---,---,---.&&",
                column  37, rpt.tot_per2 using "---,---,---.&&",
                column  52, rpt.tot_per3 using "---,---,---.&&",
                column  67, rpt.tot_per4 using "---,---,---.&&"
end report
# report1()

