########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_check.4gs/lowlevel.4gl  1.12  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    # Trap fatal errors
    whenever error call error_handler

    if group_key = "first_row" then
        # insert "on first row" code here
        if p_chck_no is not null
        then
            let rpt.chck_no = p_chck_no - 1
        end if
        return
    end if

    if group_key = "doc_no" then
        # insert "before group of doc_no" code here
        let p_counter = 1
        if p_chck_no is not null then let rpt.chck_no = rpt.chck_no + 1
          else let rpt.chck_no = curs.check_no end if
        if p_chck_date is not null then let rpt.chck_date = p_chck_date
          else let rpt.chck_date = curs.chk_date end if
        let rpt.vend_code = curs.vend_code
        call ap_vendn(rpt.vend_code) returning rpt.vend_name
        let rpt.doc_no = curs.doc_no
        let rpt.oa_amt = curs.oa_amt
        let rpt.ap_type = curs.ap_type
        let rpt.doc_desc = curs.doc_desc
        return
    end if

    if group_key = "due_date" then
        # insert "before group of due_date" code here
        return
    end if

    if group_key = "inv_doc_no" then
        # insert "before group of inv_doc_no" code here
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    let p_counter = p_counter + 1
    if p_chck_no is not null and (p_counter mod 17) = 0
    then
        let rpt.chck_no = rpt.chck_no + 1 using "##########"
    end if
    let rpt.inv_doc_no = curs.inv_doc_no
    let rpt.inv_no = curs.inv_no
    let rpt.inv_date = curs.inv_date
    let rpt.orig_amount = curs.orig_amount
    let rpt.disc_amt = curs.disc_amt
    let rpt.dist_amt = curs.dist_amt
    if curs.dist_deb_cred = "CR"
    then
      let rpt.dist_amt = rpt.dist_amt * -1
    end if
    if curs.disc_deb_cred = "DB"
    then
      let rpt.disc_amt = rpt.disc_amt * -1
    end if
    if curs.oa_deb_cred = "CR"
    then
      let rpt.oa_amt = rpt.oa_amt * -1
    end if
    if curs.ap_type = "N"
    then
        let rpt.amount_pay = curs.cash_amt
    else
        let rpt.amount_pay = rpt.dist_amt - rpt.disc_amt
    end if
    let rpt.cash_amt = null
    let rpt.cheque_amt = "******VOID******"
    let rpt.pay_to_name = null
    let rpt.address1 = null
    let rpt.address2 = null
    let rpt.address3 = null
    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20),   # group identification
        scratch char(13),
        tmpchk char(10)

    if group_key = "doc_no" then
        # insert "after group of doc_no" code here
        let scratch = curs.cash_amt using "##########.##"
        if (p_counter mod 17) = 0
        then
            let rpt.inv_doc_no = null
            let rpt.inv_no = null
            let rpt.inv_date = null
            let rpt.orig_amount = null
            let rpt.disc_amt = null
            let rpt.dist_amt = null
            let rpt.amount_pay = null
            call ml_output()
            let rpt.inv_doc_no = curs.inv_doc_no
            let rpt.inv_no = curs.inv_no
            let rpt.inv_date = curs.inv_date
            let rpt.orig_amount = curs.orig_amount
            let rpt.disc_amt = curs.disc_amt
            let rpt.dist_amt = curs.dist_amt
            let rpt.amount_pay = rpt.dist_amt - rpt.disc_amt
        end if

        let rpt.cash_amt = curs.cash_amt
        if rpt.cash_amt > 0
        then
          let rpt.cheque_amt = english_num(curs.cash_amt,true)
        end if
        if curs.pay_to_name is not null
        then
            let rpt.pay_to_name = curs.pay_to_name
            let rpt.address1 = curs.address1
            let rpt.address2 = curs.address2
        else
            select
                stpvendr.bus_name, stpvendr.address1, stpvendr.address2,
                stpvendr.city, stpvendr.state, stpvendr.zip,
                stpvendr.country
              into
                rpt.pay_to_name, rpt.address1, rpt.address2,
                curs.city, curs.state, curs.zip, curs.country
              from stpvendr
              where stpvendr.vend_code = rpt.vend_code
        end if
        if rpt.address2 is not null
        then
            let rpt.address3 =
                curs.city clipped, " ",
                curs.state clipped, " ",
                curs.zip clipped, " ",
                curs.country clipped
        else
            let rpt.address2 =
                curs.city clipped, " ",
                curs.state clipped, " ",
                curs.zip clipped, " ",
                curs.country clipped
            let rpt.address3 = null
        end if

        let tmpchk = rpt.chck_no
        update stpcashe
          set
            chk_date = rpt.chck_date,
            check_no = tmpchk,
            chk_printed = "Y"
          where
            stpcashe.doc_no = rpt.doc_no
        return
    end if

    if group_key = "due_date" then
        # insert "before group of due_date" code here
        return
    end if

    if group_key = "inv_doc_no" then
        # insert "before group of inv_doc_no" code here
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()

#######################################################################
function english_num(amount, cent_flag)
# returns numeric english string
#######################################################################
# This function takes a decimal value and converts it into an english
# string. The cent_flag argument, if false, suppresses the fractional
# portion of the result string. The precision of a decimal(11,2) is the
# greatest precision possible because a larger value cannot be assigned
# to an integer. (There are other ways to work the logic to get around
# this but for our purposes the 999,999,999.99 limit is just fine.)
#
    define
        amount  decimal(11),            # maximum precision possible
        cent_flag smallint,             # flag to suppress fractional tag
        cents   smallint,               # number of cents
        dollars integer,                # working number of dollars
        temp_int integer,               # integer value to prevent rounding
        dash    char(1),                # space/dash holder
        result  char(130),              # result string
        one_array array[9] of char(5),  # array of 'one' values
        ten_array array[9] of char(7),  # array of 'ten' values
        teen_array array[9] of char(9)  # array of 'teen' values

    # build number arrays
    let one_array[1] = "ONE"
    let one_array[2] = "TWO"
    let one_array[3] = "THREE"
    let one_array[4] = "FOUR"
    let one_array[5] = "FIVE"
    let one_array[6] = "SIX"
    let one_array[7] = "SEVEN"
    let one_array[8] = "EIGHT"
    let one_array[9] = "NINE"

    let ten_array[1] = "TEN"
    let ten_array[2] = "TWENTY"
    let ten_array[3] = "THIRTY"
    let ten_array[4] = "FORTY"
    let ten_array[5] = "FIFTY"
    let ten_array[6] = "SIXTY"
    let ten_array[7] = "SEVENTY"
    let ten_array[8] = "EIGHTY"
    let ten_array[9] = "NINETY"

    let teen_array[1] = "ELEVEN"
    let teen_array[2] = "TWELVE"
    let teen_array[3] = "THIRTEEN"
    let teen_array[4] = "FOURTEEN"
    let teen_array[5] = "FIFTEEN"
    let teen_array[6] = "SIXTEEN"
    let teen_array[7] = "SEVENTEEN"
    let teen_array[8] = "EIGHTEEN"
    let teen_array[9] = "NINETEEN"

    # initialize result and dash string
    let result = "*"    # fix for bug with 'clipped'
    let dash = " "

    # check for a negative amount
    if amount < 0
    then
        let amount = amount * -1
        let result = "* negative"
    end if

    # break apart the amount
    let dollars = amount
    let cents = (amount - dollars) * 100.0

    # build millions string
    if dollars >= 1000000
    then
        let temp_int = dollars/1000000   # fix for post evaluation bug (RDS)
        let result = result clipped, dash,
            english_num(temp_int, false) clipped,
            " MILLION"
        let dollars = dollars mod 1000000
    end if

    # build thousands string
    if dollars >= 1000
    then
        let temp_int = dollars/1000      # fix for post evaluation bug (RDS)
        let result = result clipped, dash,
            english_num(temp_int, false) clipped,
            " THOUSAND"
        let dollars = dollars mod 1000
    end if

    # build hundreds string
    if dollars >= 100
    then
        let result = result clipped, dash, one_array[dollars/100] clipped,
            " HUNDRED"
        let dollars = dollars mod 100
    end if

    # build tens string
    if dollars >= 10
    then
        if dollars >= 20 or dollars = 10
        then
            let result = result clipped, dash, ten_array[dollars/10]
            if dollars >= 20
            then
                let dash = "-"
            end if
            let dollars = dollars mod 10
        else
            let dollars = dollars mod 10  # bug won't allow this within []s
            let result = result clipped, dash, teen_array[dollars]
            let dollars = 0
        end if
    end if

    # build dollars string
    if dollars > 0
    then
        let result = result clipped, dash, one_array[dollars]
    end if

    # tack on cents
    if result = "*" or result = "* negative"
    then
        let result = result clipped, " ZERO"
    end if
    if cent_flag
    then
        let result = result clipped, " AND ", cents using "&&", "/100"
    end if

    # strip off leading "* " (fix for bug with 'clipped')
    let result = result[3,130]

    return result
end function
# english_num()

