########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_check.4gs/midlevel.4gl  1.11  Delta: 1/11/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote    char(1)    # storage for the quote

    # Trap fatal errors
    whenever error call error_handler

    let quote = "\""
    let p_sel_join =
        "stpcashe.doc_no = stpcashd.doc_no and ",
        "stpcashe.print_chk = ", quote, "Y", quote, " and ",
        "stpcashd.inv_doc_no = stpopend.doc_no and ",
        "stpcashe.vend_code = stppytor.vend_code and ",
        "stpcashe.pay_to_code = stppytor.pay_to_code and ",
        "(stpcashd.dist_amt != 0 or stpcashd.disc_amt != 0)"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter = sel_cash_acct()
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order =
        "stpcashe.doc_no, stpcashd.due_date, stpcashd.inv_doc_no"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from stpcashe, outer (stpcashd, stpopend), outer stppytor ",
        "where (", p_sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    define
        valid_chk smallint    #boolean
    
    let valid_chk = true
    call sel_wind()
    display "Entering a starting check number will cause all checks to be" 
    at 5,4
    display "printed with a sequential check number, beginning with the number"
    at 6,4
    display "entered here.  If you do not enter a starting check number,"
    at 7,4
    display "the check number that will appear on the check will be taken"
    at 8,4
    display "from the entry in the Check Number field on the A/P or Non-A/P"
    at 9,4
    display "Checks form.  If the Check Number field does not contain an entry,"
    at 10,4
    display "that check will be printed without a check number."
    at 11,4
    while valid_chk
        let valid_chk = false
        whenever error continue 
        prompt "  Enter Starting Check No.: " for p_chck_no
        if status != 0
        then
            let status = 0
            let valid_chk = true
            call fg_err(1) #invalid check number
        end if 
        whenever error call error_handler
    end while
    close window selwin
    let valid_chk = true
    call sel_wind()
    display "Entering a check date will cause all checks to be printed with"
    at 5,4
    display "the date specified.  If you do not specify a check date"
    at 6,4
    display "the date that will be printed on each check will be taken"
    at 7,4
    display "from the Date field on the A/P or Non-A/P Checks form."
    at 8,4
    while valid_chk
        let valid_chk = false
        whenever error continue 
            prompt "  Enter Check Date: " for p_chck_date
        whenever error call error_handler
        if status != 0
        then
            let status = 0
            let valid_chk = true
            call fg_err(2) #invalid check date
        end if 
    end while
    close window selwin
    let ct.sel_stmt =
        "select ",
            "stpcashd.dist_deb_cred, ",
            "stpcashd.disc_deb_cred, ",
            "stpcashe.oa_deb_cred, ",
            "stpcashe.cash_acct, ",
            "stpcashe.cash_department, ",
            "stpcashe.check_no, ",
            "stpcashe.chk_date, ",
            "stpcashe.doc_no, ",
            "stpcashe.ap_type, ",
            "stpcashe.doc_desc, ",
            "stppytor.city, ",
            "stppytor.state, ",
            "stppytor.zip, ",
            "stppytor.country, ",
            "stpcashe.oa_amt, ",
            "stpcashd.inv_doc_no, ",
            "stpcashd.inv_no, ",
            "stpcashd.due_date, ",
            "stpopend.inv_date, ",
            "stpopend.orig_amount, ",
            "stpcashd.disc_amt, ",
            "stpcashd.dist_amt, ",
            "stpcashe.vend_code, ",
            "stpcashe.cash_amt, ",
            "stppytor.pay_to_name, ",
            "stppytor.address1, ",
            "stppytor.address2 ",
        "from stpcashe, outer(stpcashd,stpopend), outer stppytor ",
        "where (", p_sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.dist_deb_cred = curs_next.dist_deb_cred
    let curs.disc_deb_cred = curs_next.disc_deb_cred
    let curs.oa_deb_cred = curs_next.oa_deb_cred
    let curs.cash_acct = curs_next.cash_acct
    let curs.cash_department = curs_next.cash_department
    let curs.check_no = curs_next.check_no
    let curs.chk_date = curs_next.chk_date
    let curs.doc_no = curs_next.doc_no
    let curs.ap_type = curs_next.ap_type
    let curs.doc_desc = curs_next.doc_desc
    let curs.city = curs_next.city
    let curs.state = curs_next.state
    let curs.zip = curs_next.zip
    let curs.country = curs_next.country
    let curs.oa_amt = curs_next.oa_amt
    let curs.inv_doc_no = curs_next.inv_doc_no
    let curs.inv_no = curs_next.inv_no
    let curs.due_date = curs_next.due_date
    let curs.inv_date = curs_next.inv_date
    let curs.orig_amount = curs_next.orig_amount
    let curs.disc_amt = curs_next.disc_amt
    let curs.dist_amt = curs_next.dist_amt
    let curs.vend_code = curs_next.vend_code
    let curs.cash_amt = curs_next.cash_amt
    let curs.pay_to_name = curs_next.pay_to_name
    let curs.address1 = curs_next.address1
    let curs.address2 = curs_next.address2
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("doc_no")
        let no_break = false
    end if
    if no_break and curs.due_date = curs_next.due_date
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("due_date")
        let no_break = false
    end if
    if no_break and curs.inv_doc_no = curs_next.inv_doc_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("inv_doc_no")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        call after_group("doc_no")
        let no_break = false
    end if
    if no_break and curs.due_date = curs_next.due_date
    then else
        call after_group("due_date")
        let no_break = false
    end if
    if no_break and curs.inv_doc_no = curs_next.inv_doc_no
    then else
        call after_group("inv_doc_no")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Accounts Payable Checks"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "10"
end function
# ml_defaults()
