########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_check.4gs/report.4gl  1.15  Delta: 2/5/91
########################################################################
#
########################################################################
# This report format is designed to fit on form number 091025 from
# Deluxe Computer Forms (phone 1-800-328-0304).  Use FourGen Accounting
# code C06798 when ordering.
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            doc_no like stpcashe.doc_no,
            ap_type like stpcashe.ap_type,
            doc_desc like stpcashe.doc_desc,
            oa_amt like stpcashe.oa_amt,
            inv_doc_no like stpcashd.inv_doc_no,
            inv_no like stpcashd.inv_no,
            inv_date like stpopend.inv_date,
            orig_amount like stpopend.orig_amount,
            amount_pay like stpopend.balance,
            disc_amt like stpcashd.disc_amt,
            dist_amt like stpcashd.dist_amt,
            chck_no like stpcashe.check_no,
            chck_date date,
            vend_code like stpcashe.vend_code,
            cheque_amt char(70),
            cash_amt like stpcashe.cash_amt,
            vend_name like stpvendr.bus_name,
            pay_to_name like stppytor.pay_to_name,
            address1 like stppytor.address1,
            address2 char(60),
            address3 char(60)
        end record,
        last_trlr record
                chck_no like stpcashe.check_no,
                chck_date date,
                vend_code like stpvendr.vend_code,
                cheque_amt char(70),
                cash_amt like stpcashe.cash_amt,
                pay_to_name char(30),
                address1 like stppytor.address1,
                address2 char(60),
                address3 char(60)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint,       # working number
        after_group smallint

    output
        top margin     1
        bottom margin  3
        left margin    0
        right margin   85
        page length    42

    order external by rpt.doc_no

    format

        page header
            # Trap fatal errors
            whenever error call error_handler
            print column 10, rpt.vend_name
            print
            print

        page trailer
            if after_group is null
            then
                let after_group = false
            end if
            if after_group
            then
                let after_group = false
            else
                let last_trlr.chck_no = rpt.chck_no
                let last_trlr.chck_date = rpt.chck_date
                let last_trlr.vend_code = rpt.vend_code
                let last_trlr.cheque_amt = rpt.cheque_amt
                let last_trlr.cash_amt = rpt.cash_amt
                let last_trlr.pay_to_name = rpt.pay_to_name
                let last_trlr.address1 = rpt.address1
                let last_trlr.address2 = rpt.address2
                let last_trlr.address3 = rpt.address3
            end if
            print
            print
            print
            print
            print
            print
                column  47, last_trlr.chck_no,
                column  60, last_trlr.chck_date,
                column  71, last_trlr.vend_code
            print
            print
            print
            print
                column  62, last_trlr.cash_amt using "$$$,$$$,$$$.##"
            print
                column  5, last_trlr.cheque_amt
            print
            print
            print
                column  10, last_trlr.pay_to_name
            print
                column  10, last_trlr.address1
            print
                column  10, last_trlr.address2
            print
                column  10, last_trlr.address3
            print

        before group of rpt.doc_no
           skip to top of page
           if rpt.oa_amt is null or
              rpt.oa_amt = 0 or
              rpt.ap_type = "N"
           then
                print
           else
                print
                column  46, "ON ACCOUNT",
                column  67, rpt.oa_amt using "--------&.&&"
           end if

        on every row
            if rpt.ap_type = "N"
            then
                print
                    column  18, rpt.chck_date,
                    column  27, rpt.doc_desc,
                    column  67, rpt.amount_pay using "--------&.&&"
            else
                print
                    column   1, rpt.inv_doc_no using "<<<<<<",
                    column   7, rpt.inv_no,
                    column  18, rpt.inv_date,
                    column  27, rpt.orig_amount using "--------&.&&",
                    column  40, rpt.dist_amt using "--------&.&&",
                    column  53, rpt.disc_amt using "--------&.&&",
                    column  67, rpt.amount_pay using "--------&.&&"
            end if

        after group of rpt.doc_no
            let after_group = true
            let last_trlr.chck_no = rpt.chck_no
            let last_trlr.chck_date = rpt.chck_date
            let last_trlr.vend_code = rpt.vend_code
            let last_trlr.cheque_amt = rpt.cheque_amt
            let last_trlr.cash_amt = rpt.cash_amt
            let last_trlr.pay_to_name = rpt.pay_to_name
            let last_trlr.address1 = rpt.address1
            let last_trlr.address2 = rpt.address2
            let last_trlr.address3 = rpt.address3

end report
# report1()

