########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_chkreg.4gs/report.4gl  1.9  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            doc_no like stxckrgd.doc_no,
            incr_with_crdt like stxchrtr.incr_with_crdt,
            debit_credit like stxckrgd.debit_credit,
            amount like stxckrgd.amount,
            co_name like stxcntrc.co_name,
            acct_no like stxckrgr.acct_no,
            department like stxckrgr.department,
            acct_desc like stxchrtr.acct_desc,
            start_date date,
            beg_amount decimal(12),
            bal_amount decimal(12),
            doc_date like stxtranr.doc_date,
            inv_chk_no like stxckrgd.inv_chk_no,
            orig_journal like stxckrgd.orig_journal,
            ref_code like stxtranr.ref_code,
            doc_desc like stxtranr.doc_desc,
            line_amount decimal(12),
            end_date date,
            reconciled like stxckrgd.reconciled,
            asterisk char(1),
            rec_message char(80)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    order external by rpt.acct_no, rpt.department, rpt.doc_date, rpt.orig_journal, rpt.inv_chk_no

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Checking Account Reconciliation"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column  25, "Between ",
                column  33, rpt.start_date using "mm/dd/yy",
                column  42, "and ",
                column  46, rpt.end_date using "mm/dd/yy"
            print
            print
                column   1, "Checking Account: ",
                column  19, rpt.acct_no using "######" clipped,
                            "-" clipped,
                            rpt.department clipped,
                            " ", rpt.acct_desc
            print
            print
                column   1, "R",
                column   5, "Date",
                column  12, "OJ Ref.No.",
                column  26, "Ref.Code",
                column  36, "Description",
                column  75, "Amount"
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Checking Account Reconciliation";
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.department
            skip to top of page
            print
                column   3, rpt.start_date using "mm/dd/yy",
                column  31, "Beginning Balance",
                column  67, rpt.beg_amount using "---,---,---.&&"

        on every row
            if
                rpt.doc_date is not null
             or rpt.inv_chk_no is not null
             or rpt.orig_journal is not null
             or rpt.ref_code is not null
             or rpt.doc_desc is not null
             or rpt.line_amount is not null
            then
                print
                    column   1, rpt.asterisk,
                    column   3, rpt.doc_date using "mm/dd/yy",
                    column  12, rpt.orig_journal,
                    column  15, rpt.inv_chk_no,
                    column  26, rpt.ref_code,
                    column  33, rpt.doc_desc,
                    column  62, rpt.line_amount using "---,---,---.&&"
            end if

        after group of rpt.orig_journal
            need 2 lines
            print
                column  31, "Balance after ",
                column  45, rpt.doc_date using "mm/dd/yy",
                column  54, rpt.orig_journal,
                column  67, rpt.bal_amount using "---,---,---.&&"
            print

        after group of rpt.department
            need 2 lines
            print
                column  67, "=============="
            print
                column   3, rpt.end_date using "mm/dd/yy",
                column  31, "Ending Balance",
                column  67, group sum(rpt.line_amount) + rpt.beg_amount using "---,---,---.&&"
            if rpt.rec_message is not null
            then
                print
                print
                    column 1, rpt.rec_message
            end if

end report
# report1()

