########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_ckjrnl.4gs/lowlevel.4gl  1.8  Delta: 2/9/91
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    # Trap fatal errors
    whenever error call error_handler

    if group_key = "first_row" then
        # insert "on first row" code here
        let rpt.tot_inv_amt = 0
        let rpt.tot_disc_amt = 0
        let rpt.tot_chk_amt = 0
        return
    end if

    if group_key = "doc_no" then
        # insert "before group of doc_no" code here
        let rpt.chk_amt = 0
        let rpt.disc_amt = 0
        let rpt.inv_amt = 0
        return
    end if

    if group_key = "inv_chk_no" then
        # insert "before group of inv_chk_no" code here
        return
    end if

    if group_key = "inv_doc_no" then
        # insert "before group of inv_doc_no" code here
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    define
        p_description like stxchrtr.acct_desc,
        p_incr_with_crdt like stxchrtr.incr_with_crdt

    let rpt.non_ap_amount = curs.non_ap_amount
    let rpt.debit_credit = curs.debit_credit
    let rpt.act_type = curs.act_type
    let rpt.amount = curs.amount
    let rpt.inv_doc_no = curs.inv_doc_no
    let rpt.inv_chk_no = curs.inv_chk_no
    let rpt.doc_date = curs.doc_date
    let rpt.doc_no = curs.doc_no
    let rpt.ref_code = curs.ref_code
    let rpt.vend_desc = ap_vendn(rpt.ref_code)
    let rpt.doc_desc = curs.doc_desc
    if rpt.vend_desc = "NOT FOUND" then let rpt.vend_desc = null end if

    if curs.act_type is null   # this is a non-ap transaction
    then
      call al_chrtn(curs.acct_no) 
        returning p_description, p_incr_with_crdt

      if p_incr_with_crdt = "Y"
      then
          if curs.debit_credit = "C" 
          then 
              # we want all check amounts to print out positive, and
              # all voided check amounts to print out negative.
              let curs.non_ap_amount = curs.non_ap_amount * -1
          end if 
      else
          if curs.debit_credit = "D" 
          then 
              let curs.non_ap_amount = curs.non_ap_amount * -1
          end if 
      end if
      let rpt.disc_amt = 0
      let rpt.inv_amt = curs.non_ap_amount
    else
      if curs.act_type = "D" 
      then 
        let rpt.disc_amt = rpt.disc_amt + (curs.amount * -1)
      else 
        let rpt.inv_amt = rpt.inv_amt + (curs.amount * -1)
      end if
    end if

    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "doc_no" then
        # insert "after group of doc_no" code here
        let rpt.chk_amt = rpt.inv_amt - rpt.disc_amt
        let rpt.tot_inv_amt = rpt.tot_inv_amt + rpt.inv_amt
        let rpt.tot_disc_amt = rpt.tot_disc_amt + rpt.disc_amt
        let rpt.tot_chk_amt = rpt.tot_chk_amt + rpt.chk_amt
        return
    end if

    if group_key = "inv_chk_no" then
        # insert "after group of inv_chk_no" code here
        return
    end if

    if group_key = "inv_doc_no" then
        # insert "after group of inv_doc_no" code here
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()
