########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_ckjrnl.4gs/report.4gl  1.6  Delta: 2/9/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            non_ap_amount like stxckrgd.amount,
            debit_credit like stxckrgd.debit_credit,
            acct_no like stxckrgd.acct_no,
            act_type like stpactvd.act_type,
            amount like stpactvd.amount,
            inv_doc_no like stpactvd.inv_doc_no,
            co_name like stxcntrc.co_name,
            date_range char(40),
            inv_chk_no like stxckrgd.inv_chk_no,
            doc_date like stxtranr.doc_date,
            doc_no like stxtranr.doc_no,
            ref_code like stxtranr.ref_code,
            vend_desc like stpvendr.bus_name,
            doc_desc like stxtranr.doc_desc,
            inv_amt decimal(12),
            disc_amt decimal(12),
            chk_amt decimal(12),
            tot_inv_amt decimal(12),
            tot_disc_amt decimal(12),
            tot_chk_amt decimal(12)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin     3
        bottom margin  3
        left margin    0
        right margin   80
        page length    66

    order external by rpt.doc_no, rpt.inv_chk_no, rpt.inv_doc_no

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Check Journal"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
                ;
                let scratch = rpt.date_range
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
            print
                column   1, "Check No.",
                column  12, "Check Date",
                column  24, "Doc. No.",
                column  36, "Payee"
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Check Journal";
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.doc_no
            need 2 lines
            print
                column   1, rpt.inv_chk_no,
                column  12, rpt.doc_date,
                column  24, rpt.doc_no using "######",
                column  36, rpt.ref_code,
                column  44, "- ",
                column  46, rpt.vend_desc
            print
                column  46, rpt.doc_desc

        after group of rpt.doc_no
            need 5 lines
            print
            print
                column  36, "Gross",
                column  50, "Discount",
                column  72, "Net"
            print
                column  28, "-------------",
                column  45, "-------------",
                column  62, "-------------"
            print
                column  14, "Check Amount: ",
                column  28, rpt.inv_amt using "----------.&&",
                column  45, rpt.disc_amt using "----------.&&",
                column  62, rpt.chk_amt using "----------.&&"
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

        on last row
            need 5 lines
            print
            print
                column  36, "Gross",
                column  50, "Discount",
                column  72, "Net"
            print
                column  28, "-------------",
                column  45, "-------------",
                column  62, "-------------"
            print
                column   8, "Total Check Amount: ",
                column  28, rpt.tot_inv_amt using "----------.&&",
                column  45, rpt.tot_disc_amt using "----------.&&",
                column  62, rpt.tot_chk_amt using "----------.&&"
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

end report
# report1()
