########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_contrl.4gs/midlevel.4gl  1.4  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    let ct.sel_join =
        "stpcntrc.terms_code = stptermr.terms_code"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter = "1=1"
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = ""
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from stpcntrc, outer stptermr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "stpcntrc.terms_code, ",
            "stptermr.terms_desc, ",
            "stpcntrc.ap_acct_no, ",
            "stpcntrc.cd_disc_acct_no, ",
            "stpcntrc.cd_cash_acct_no, ",
            "stpcntrc.age_datetype, ",
            "stpcntrc.age_dsc1, ",
            "stpcntrc.age_dsc2, ",
            "stpcntrc.age_dsc3, ",
            "stpcntrc.age_dsc4, ",
            "stpcntrc.age_per1, ",
            "stpcntrc.age_per2, ",
            "stpcntrc.age_per3, ",
            "stpcntrc.ap_balanced ",
        "from stpcntrc, outer stptermr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.terms_code = curs_next.terms_code
    let curs.terms_desc = curs_next.terms_desc
    let curs.ap_acct_no = curs_next.ap_acct_no
    let curs.cd_disc_acct_no = curs_next.cd_disc_acct_no
    let curs.cd_cash_acct_no = curs_next.cd_cash_acct_no
    let curs.age_datetype = curs_next.age_datetype
    let curs.age_dsc1 = curs_next.age_dsc1
    let curs.age_dsc2 = curs_next.age_dsc2
    let curs.age_dsc3 = curs_next.age_dsc3
    let curs.age_dsc4 = curs_next.age_dsc4
    let curs.age_per1 = curs_next.age_per1
    let curs.age_per2 = curs_next.age_per2
    let curs.age_per3 = curs_next.age_per3
    let curs.ap_balanced = curs_next.ap_balanced
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Accounts Payable Defaults"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let rpt.co_name = al_compn()
end function
# ml_defaults()

