########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_contrl.4gs/report.4gl  1.7  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            co_name like stxcntrc.co_name,
            terms_code like stpcntrc.terms_code,
            terms_desc like stptermr.terms_desc,
            ap_acct_no like stpcntrc.ap_acct_no,
            cd_disc_acct_no like stpcntrc.cd_disc_acct_no,
            cd_cash_acct_no like stpcntrc.cd_cash_acct_no,
            age_datetype like stpcntrc.age_datetype,
            age_dsc1 like stpcntrc.age_dsc1,
            age_dsc2 like stpcntrc.age_dsc2,
            age_dsc3 like stpcntrc.age_dsc3,
            age_dsc4 like stpcntrc.age_dsc4,
            age_per1 like stpcntrc.age_per1,
            age_per2 like stpcntrc.age_per2,
            age_per3 like stpcntrc.age_per3,
            ap_balanced like stpcntrc.ap_balanced
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80
        page length     66

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Accounts Payable Defaults"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Accounts Payable Defaults";
                let scratch = pageno using "Page: <<<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        on every row
            need 18 lines
            print
                column  27, "Accounts Payable Defaults"
            print
                column   1, "-------------------------------- Invoici",
                column  41, "ng ---------------------------------"
            print
            print
                column   5, "Terms Code: ",
                column  17, rpt.terms_code,
                column  26, rpt.terms_desc
            print
            print
                column   1, "----------------------------- Account Nu",
                column  41, "mbers ------------------------------"
            print
            print
                column  12, "A/P: ",
                column  17, rpt.ap_acct_no using "######",
                column  28, "Cash: ",
                column  34, rpt.cd_cash_acct_no using "######",
                column  47, "Discount: ",
                column  57, rpt.cd_disc_acct_no using "######"
            print
            print
                column   1, "---------------------------- Aging Infor",
                column  41, "mation -----------------------------"
            print
            print
                column   9, "Age On: ",
                column  17, rpt.age_datetype,
                column  23, "(D - Due Date, I - Invoice Date)"
            print
                column   3, "Descriptions:"
            print
                column   3, rpt.age_dsc1,
                column  21, rpt.age_dsc2,
                column  39, rpt.age_dsc3,
                column  57, rpt.age_dsc4
            print
                column   4, "---------------",
                column  22, "---------------",
                column  40, "---------------",
                column  58, "---------------"
            print
                column   6, "Days: ",
                column  12, rpt.age_per1,
                column  30, rpt.age_per2,
                column  48, rpt.age_per3
            print
                column   1, "----------------------------------------",
                column  41, "------------------------------------"
            print
                column  19, "Accounts Payable Setup Complete?: ",
                column  53, rpt.ap_balanced

end report
# report1()

