########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_termls.4gs/report.4gl  1.5  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            co_name like stxcntrc.co_name,
            terms_code like stptermr.terms_code,
            terms_desc like stptermr.terms_desc,
            due_days like stptermr.due_days,
            disc_days like stptermr.disc_days,
            disc_pct like stptermr.disc_pct
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Vendor Terms"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
                column   1, "Code",
                column   9, "Description",
                column  40, "Due days",
                column  52, "Disc days",
                column  66, "Disc percent"
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Vendor Terms";
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        on every row
            print
                column   1, rpt.terms_code,
                column   9, rpt.terms_desc,
                column  42, rpt.due_days using "###",
                column  54, rpt.disc_days using "###",
                column  69, rpt.disc_pct using "#&.&&&"

end report
# report1()

