########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_vendbl.4gs/lowlevel.4gl  1.4  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20),    # group identification
        save record
            on_acct_amt like stpvendr.on_acct_amt,
            vend_code like stpvendr.vend_code,
            bus_name like stpvendr.bus_name,
            doc_no like stpopend.doc_no,
            inv_no like stpopend.inv_no,
            inv_date like stpopend.inv_date,
            inv_desc like stpopend.inv_desc,
            balance like stpopend.balance
        end record

    # Trap fatal errors
    whenever error call error_handler

    if group_key = "first_row" then
        # insert "on first row" code here
        let rpt.tot_bal = 0
        return
    end if

    if group_key = "vend_code" then
        # insert "before group of vend_code" code here
        let rpt.acct_bal = 0
        if curs.on_acct_amt is not null and curs.on_acct_amt != 0
        then 
          let save.* = curs.*
          let curs.inv_desc = "On Account"
          let curs.balance = curs.on_acct_amt
          let curs.inv_date = ""
          let curs.doc_no = ""
          let curs.inv_no = ""
          call on_every_row()
          call ml_output()
          let curs.* = save.*
        end if
        return
    end if

    if group_key = "doc_no" then
        # insert "before group of doc_no" code here
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    let rpt.vend_code = curs.vend_code
    let rpt.on_acct_amt = curs.on_acct_amt
    let rpt.bus_name = curs.bus_name
    let rpt.doc_no = curs.doc_no
    let rpt.inv_no = curs.inv_no
    let rpt.inv_date = curs.inv_date
    let rpt.inv_desc = curs.inv_desc
    let rpt.balance = curs.balance
    if rpt.balance is not null 
    then
      let rpt.acct_bal = rpt.acct_bal + rpt.balance
      let rpt.tot_bal = rpt.tot_bal + rpt.balance
    end if
    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "vend_code" then
        # insert "after group of vend_code" code here
        return
    end if

    if group_key = "doc_no" then
        # insert "after group of doc_no" code here
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()


