########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_vendbl.4gs/report.4gl  1.6  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            on_acct_amt like stpvendr.on_acct_amt,
            co_name like stxcntrc.co_name,
            vend_code like stpvendr.vend_code,
            bus_name like stpvendr.bus_name,
            doc_no like stpopend.doc_no,
            inv_no like stpopend.inv_no,
            inv_date like stpopend.inv_date,
            inv_desc like stpopend.inv_desc,
            balance like stpopend.balance,
            acct_bal like stpvendr.acct_bal,
            tot_bal like stpvendr.acct_bal
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    order external by rpt.vend_code, rpt.doc_no

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Vendor Open Items"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
                column   1, "Doc No.",
                column  11, "Invoice",
                column  22, "Date",
                column  32, "Description",
                column  70, "Balance"
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Vendor Open Items";
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.vend_code
            print
                column   1, rpt.vend_code clipped,
                            " ", "-" clipped,
                            " ", rpt.bus_name

        on every row
            if
                rpt.doc_no is not null
             or rpt.inv_no is not null
             or rpt.inv_date is not null
             or rpt.inv_desc is not null
             or rpt.balance is not null
            then
                print
                    column   1, rpt.doc_no using "######",
                    column  11, rpt.inv_no,
                    column  22, rpt.inv_date using "mm/dd/yy",
                    column  32, rpt.inv_desc,
                    column  63, rpt.balance using "---,---,---.&&"
            end if

        after group of rpt.vend_code
            need 3 lines
            print
                column  60, "-----------------"
            print
                column  32, "Vendor Balance:",
                column  63, rpt.acct_bal using "---,---,---.&&"
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

        on last row
            need 3 lines
            print
                column  60, "================="
            print
                column  26, "Total Vendor Balance:",
                column  63, rpt.tot_bal using "---,---,---.&&"
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

end report
# report1()

