########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_venddt.4gs/midlevel.4gl  1.5  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    let ct.sel_join =
        "stpvendr.terms_code = stptermr.terms_code and ",
        "stpvendr.act_grp = stxactgr.grp_key and ",
        "stpvendr.vend_code = stppytor.vend_code"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    call sel_vend() returning ct.sel_filter
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "stpvendr.vend_code, stppytor.pay_to_code"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from stpvendr, outer stptermr, outer stxactgr, outer stppytor ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_rows
    close count_cursor
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    define
        p_sel_stmt char(2048)   # alternate select statement for cursor

    let p_sel_stmt =
        "select ",
            "stpvendr.vend_code, ",
            "stpvendr.bus_name, ",
            "stpvendr.contact, ",
            "stpvendr.phone, ",
            "stpvendr.address1, ",
            "stpvendr.address2, ",
            "stpvendr.city, ",
            "stpvendr.state, ",
            "stpvendr.zip, ",
            "stpvendr.country, ",
            "stpvendr.spec_billing, ",
            "stpvendr.credit_limit, ",
            "stpvendr.ap_acct_dflt, ",
            "stpvendr.ap_department_dflt, ",
            "stpvendr.terms_code, ",
            "stptermr.terms_desc, ",
            "stpvendr.act_grp, ",
            "stxactgr.grp_desc, ",
            "stpvendr.last_pay_date, ",
            "stpvendr.hold_pymnt, ",
            "stpvendr.take_dscnt, ",
            "stpvendr.print_1099, ",
            "stpvendr.federal_tax_id, ",
            "stpvendr.cash_acct_no, ",
            "stpvendr.cash_department, ",
            "stpvendr.on_acct_amt, ",
            "stpvendr.acct_bal, ",
            "stppytor.pay_to_code, ",
            "stppytor.pay_to_name, ",
            "stppytor.contact, ",
            "stppytor.address1, ",
            "stppytor.phone, ",
            "stppytor.address2, ",
            "stppytor.city, ",
            "stppytor.state, ",
            "stppytor.zip, ",
            "stppytor.country, ",
            "stppytor.take_dscnt ",
        "from stpvendr, outer stptermr, outer stxactgr, outer stppytor ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let p_sel_stmt = p_sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    prepare get_curs from p_sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.vend_code = curs_next.vend_code
    let curs.bus_name = curs_next.bus_name
    let curs.contact = curs_next.contact
    let curs.phone = curs_next.phone
    let curs.address1 = curs_next.address1
    let curs.address2 = curs_next.address2
    let curs.city = curs_next.city
    let curs.state = curs_next.state
    let curs.zip = curs_next.zip
    let curs.country = curs_next.country
    let curs.spec_billing = curs_next.spec_billing
    let curs.credit_limit = curs_next.credit_limit
    let curs.ap_acct_dflt = curs_next.ap_acct_dflt
    let curs.ap_department_dflt = curs_next.ap_department_dflt
    let curs.terms_code = curs_next.terms_code
    let curs.terms_desc = curs_next.terms_desc
    let curs.act_grp = curs_next.act_grp
    let curs.grp_desc = curs_next.grp_desc
    let curs.last_pay_date = curs_next.last_pay_date
    let curs.hold_pymnt = curs_next.hold_pymnt
    let curs.take_dscnt = curs_next.take_dscnt
    let curs.print_1099 = curs_next.print_1099
    let curs.federal_tax_id = curs_next.federal_tax_id
    let curs.cash_acct_no = curs_next.cash_acct_no
    let curs.cash_department = curs_next.cash_department
    let curs.on_acct_amt = curs_next.on_acct_amt
    let curs.acct_bal = curs_next.acct_bal
    let curs.pay_to_code = curs_next.pay_to_code
    let curs.pay_to_name = curs_next.pay_to_name
    let curs.pay_contact = curs_next.pay_contact
    let curs.pay_address1 = curs_next.pay_address1
    let curs.pay_phone = curs_next.pay_phone
    let curs.pay_address2 = curs_next.pay_address2
    let curs.pay_city = curs_next.pay_city
    let curs.pay_state = curs_next.pay_state
    let curs.pay_zip = curs_next.pay_zip
    let curs.pay_country = curs_next.pay_country
    let curs.pay_take_dscnt = curs_next.pay_take_dscnt
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.vend_code = curs_next.vend_code
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("vend_code")
        let no_break = false
    end if
    if no_break and curs.pay_to_code = curs_next.pay_to_code
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("pay_to_code")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.vend_code = curs_next.vend_code
    then else
        call after_group("vend_code")
        let no_break = false
    end if
    if no_break and curs.pay_to_code = curs_next.pay_to_code
    then else
        call after_group("pay_to_code")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Vendor Information Detail"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "10"
    let rpt.co_name = al_compn()
end function
# ml_defaults()

