########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_venddt.4gs/report.4gl  1.7  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            co_name like stxcntrc.co_name,
            vend_code like stpvendr.vend_code,
            bus_name like stpvendr.bus_name,
            contact like stpvendr.contact,
            phone like stpvendr.phone,
            address1 like stpvendr.address1,
            address2 like stpvendr.address2,
            city like stpvendr.city,
            state like stpvendr.state,
            zip like stpvendr.zip,
            country like stpvendr.country,
            spec_billing like stpvendr.spec_billing,
            credit_limit like stpvendr.credit_limit,
            ap_acct_dflt like stpvendr.ap_acct_dflt,
            ap_department_dflt like stpvendr.ap_department_dflt,
            terms_code like stpvendr.terms_code,
            terms_desc like stptermr.terms_desc,
            act_grp like stpvendr.act_grp,
            grp_desc like stxactgr.grp_desc,
            last_pay_date like stpvendr.last_pay_date,
            hold_pymnt like stpvendr.hold_pymnt,
            take_dscnt like stpvendr.take_dscnt,
            print_1099 like stpvendr.print_1099,
            federal_tax_id like stpvendr.federal_tax_id,
            cash_acct_no like stpvendr.cash_acct_no,
            cash_department like stpvendr.cash_department,
            on_acct_amt like stpvendr.on_acct_amt,
            acct_bal like stpvendr.acct_bal,
            pay_to_code like stppytor.pay_to_code,
            pay_to_name like stppytor.pay_to_name,
            pay_contact like stppytor.contact,
            pay_address1 like stppytor.address1,
            pay_phone like stppytor.phone,
            pay_address2 like stppytor.address2,
            pay_city like stppytor.city,
            pay_state like stppytor.state,
            pay_zip like stppytor.zip,
            pay_country like stppytor.country,
            pay_take_dscnt like stppytor.take_dscnt
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    order external by rpt.vend_code, rpt.pay_to_code

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Vendor Information Detail"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Vendor Information Detail";
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.vend_code
            skip to top of page
            if
                rpt.pay_to_code is not null
             or rpt.pay_to_name is not null
             or rpt.pay_contact is not null
             or rpt.pay_address1 is not null
             or rpt.pay_phone is not null
             or rpt.pay_address2 is not null
             or rpt.pay_city is not null
             or rpt.pay_state is not null
             or rpt.pay_zip is not null
             or rpt.pay_country is not null
             or rpt.pay_take_dscnt is not null
            then
                let dynamic = true
                need 17 lines
            else
                let dynamic = false
                need 15 lines
            end if

            print
                column  11, "Vendor Code: ",
                column  24, rpt.vend_code
            print
                column   9, "Business Name: ",
                column  24, rpt.bus_name
            print
                column  15, "Contact: ",
                column  24, rpt.contact,
                column  48, "Phone: ",
                column  55, rpt.phone
            print
                column  13, "Address 1: ",
                column  24, rpt.address1
            print
                column  13, "Address 2: ",
                column  24, rpt.address2
            print
                column   6, "City, State, Zip: ",
                column  24, rpt.city clipped,
                            " ", rpt.state clipped,
                            " ", rpt.zip
            print
                column  15, "Country: ",
                column  24, rpt.country
            print
                column   3, "Pay-To Instructions: ",
                column  24, rpt.spec_billing
            print
                column  10, "Credit Limit: ",
                column  24, rpt.credit_limit,
                column  45, "1099 Required: ",
                column  60, rpt.print_1099,
                column  64, "TIN: ",
                column  69, rpt.federal_tax_id
            print
                column   3, "Default A/P Account: ",
                column  24, rpt.ap_acct_dflt using "######",
                column  30, "-",
                column  31, rpt.ap_department_dflt,
                column  47, "Default Cash Account: ",
                column  70, rpt.cash_acct_no using "######",
                column  76, "-",
                column  77, rpt.cash_department
            print
                column  12, "Terms Code: ",
                column  24, rpt.terms_code,
                column  33, rpt.terms_desc
            print
                column   9, "Account Group: ",
                column  24, rpt.act_grp,
                column  33, rpt.grp_desc
            print
                column   5, "Last Payment Date: ",
                column  24, rpt.last_pay_date
            print
                column   4, "Hold Payment (Y/N): ",
                column  24, rpt.hold_pymnt,
                column  54, "On Account: ",
                column  66, rpt.on_acct_amt
            print
                column   2, "Always Take Discount: ",
                column  24, rpt.take_dscnt,
                column  57, "Balance: ",
                column  66, rpt.acct_bal
            if dynamic
            then
                print
            end if
            if dynamic
            then
                print
                    column   1, "------------------------------ Pay-To Ad",
                    column  41, "dress ----------------------------------"
            end if

        on every row
            need 9 lines
            if
                rpt.pay_to_code is not null
            then
                print
                    column  11, "Pay-To Code: ",
                    column  24, rpt.pay_to_code
            end if
            if
                rpt.pay_to_name is not null
            then
                print
                    column  11, "Pay-To Name: ",
                    column  24, rpt.pay_to_name
            end if
            if
                rpt.pay_contact is not null
             or rpt.pay_address1 is not null
            then
                print
                    column  15, "Contact: ",
                    column  24, rpt.pay_contact,
                    column  48, "Phone: ",
                    column  55, rpt.pay_phone
            end if
            if
                rpt.pay_address1 is not null
            then
                print
                    column  13, "Address 1: ",
                    column  24, rpt.pay_address1
            end if
            if
                rpt.pay_address2 is not null
            then
                print
                    column  13, "Address 2: ",
                    column  24, rpt.pay_address2
            end if
            if
                rpt.pay_city is not null
             or rpt.pay_state is not null
             or rpt.pay_zip is not null
            then
                print
                    column   6, "City, State, Zip: ",
                    column  24, rpt.pay_city clipped,
                                " ", rpt.pay_state clipped,
                                " ", rpt.pay_zip
            end if
            if
                rpt.pay_country is not null
            then
                print
                    column  15, "Country: ",
                    column  24, rpt.pay_country
            end if
            if
                rpt.pay_take_dscnt is not null
            then
                print
                    column   2, "Always Take Discount: ",
                    column  24, rpt.pay_take_dscnt
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

end report
# report1()

