########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_vendlb.4gs/report.4gl  1.3  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            vend_code like stpvendr.vend_code,
            bus_name like stpvendr.bus_name,
            address1 like stpvendr.address1,
            address2 like stpvendr.address2,
            city like stpvendr.city,
            state like stpvendr.state,
            zip like stpvendr.zip,
            country like stpvendr.country
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        top margin      0
        bottom margin   0
        left margin     0
        right margin    33
        page length     6

    order external by rpt.vend_code

    format
        on every row
            # Trap fatal errors
            whenever error call error_handler
            need 6 lines
            print
            print
                column   2, rpt.bus_name
            if
                rpt.address1 is not null
            then
                print
                    column   2, rpt.address1
            end if
            if
                rpt.address2 is not null
            then
                print
                    column   2, rpt.address2
            end if
            print
                column   2, rpt.city clipped,
                            "," clipped,
                            " ", rpt.state clipped,
                            " ", rpt.zip clipped,
                            " ", rpt.country
            print

end report
# report1()

