########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_vendld.4gs/lowlevel.4gl  1.3  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    # Trap fatal errors
    whenever error call error_handler

    if group_key = "first_row" then
        # insert "on first row" code here
        return
    end if

    if group_key = "ref_code" then
        # insert "before group of ref_code" code here
        let rpt.balance = curs.arch_bal
        return
    end if

    if group_key = "doc_date" then
        # insert "before group of doc_date" code here
        return
    end if

    if group_key = "doc_no" then
        # insert "before group of doc_no" code here
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#
    let rpt.doc_no = curs.doc_no
    let rpt.ref_code = curs.ref_code
    let rpt.bus_name = curs.bus_name
    let rpt.arch_bal = curs.arch_bal
    let rpt.doc_date = curs.doc_date
    let rpt.tran_type = "INVOICE"
    if curs.doc_type = "CD"
    then
        let rpt.tran_type = "PAYMENT"
    end if
    if curs.doc_type = "CM"
    then
        let rpt.tran_type = "CREDIT MEMO"
    end if
    if curs.doc_type = "DM"
    then
        let rpt.tran_type = "DEBIT MEMO"
    end if
    let rpt.inv_chk_no = curs.inv_chk_no
    let rpt.doc_desc = curs.doc_desc
    let rpt.amount = curs.amount
    let rpt.balance = rpt.balance + curs.amount
    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    if group_key = "ref_code" then
        # insert "after group of ref_code" code here
        return
    end if

    if group_key = "doc_date" then
        # insert "after group of doc_date" code here
        return
    end if

    if group_key = "doc_no" then
        # insert "after group of doc_no" code here
        return
    end if

    if group_key = "last_row" then
        # insert "on last row" code here
        return
    end if

end function
# after_group()


