########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_vendld.4gs/midlevel.4gl  1.3  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote    char(1)    # storage for the quote

    # Trap fatal errors
    whenever error call error_handler

    let quote = "\""
    let join_phrase =
        "stxtranr.doc_no = stpactvd.doc_no and ",
        "stxtranr.orig_journal = stpactvd.orig_journal and ",
        "stpactvd.act_type != ",quote,"D",quote," and ",
        "stxtranr.doc_no = stptranr.doc_no and ",
        "stxtranr.orig_journal = stptranr.orig_journal and ",
        "stpvendr.vend_code = stxtranr.ref_code"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter = sel_vend()
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = "stxtranr.ref_code, stxtranr.doc_date, stxtranr.doc_no"
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(*) ",
        "from stxtranr, stpactvd, stptranr, stpvendr ",
        "where (", join_phrase clipped,
        ") and (", ct.sel_filter clipped, ")"
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor
    fetch count_cursor into ct.num_pows
    close count_cursor
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "stxtranr.doc_no, ",
            "stxtranr.ref_code, ",
            "stpvendr.bus_name, ",
            "stpvendr.arch_bal, ",
            "stxtranr.doc_date, ",
            "stptranr.doc_type, ",
            "stptranr.inv_chk_no, ",
            "stxtranr.doc_desc, ",
            "stpactvd.amount ",
        "from stxtranr, stpactvd, stptranr, stpvendr ",
        "where (", join_phrase clipped,
        ") and (", ct.sel_filter clipped, ")"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.doc_no = curs_next.doc_no
    let curs.ref_code = curs_next.ref_code
    let curs.bus_name = curs_next.bus_name
    let curs.arch_bal = curs_next.arch_bal
    let curs.doc_date = curs_next.doc_date
    let curs.doc_type = curs_next.doc_type
    let curs.inv_chk_no = curs_next.inv_chk_no
    let curs.doc_desc = curs_next.doc_desc
    let curs.amount = curs_next.amount
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.ref_code = curs_next.ref_code
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("ref_code")
        let no_break = false
    end if
    if no_break and curs.doc_date = curs_next.doc_date
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("doc_date")
        let no_break = false
    end if
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        if no_break then call ml_curs_prep() end if
        call before_group("doc_no")
        let no_break = false
    end if
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
    if no_break and curs.ref_code = curs_next.ref_code
    then else
        call after_group("ref_code")
        let no_break = false
    end if
    if no_break and curs.doc_date = curs_next.doc_date
    then else
        call after_group("doc_date")
        let no_break = false
    end if
    if no_break and curs.doc_no = curs_next.doc_no
    then else
        call after_group("doc_no")
        let no_break = false
    end if
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    let ct.prcname = "Vendor Ledger"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.destin = "report.out"
    let ct.quiet = "10"
    let rpt.co_name = al_compn()
end function
# ml_defaults()

