########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/o_vendld.4gs/report.4gl  1.4  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            doc_no like stxtranr.doc_no,
            co_name char(30),
            ref_code like stxtranr.ref_code,
            bus_name like stpvendr.bus_name,
            arch_bal like stpvendr.arch_bal,
            doc_date like stxtranr.doc_date,
            tran_type char(11),
            inv_chk_no like stptranr.inv_chk_no,
            doc_desc like stxtranr.doc_desc,
            amount like stpactvd.amount,
            balance like stpvendr.acct_bal
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        first_group char(1),        # null means this is the first group
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    order external by rpt.ref_code, rpt.doc_date, rpt.doc_no

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Vendor Ledger"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
            print
                column   6, "A/P Activity for ",
                column  23, rpt.ref_code clipped,
                            " ", "-" clipped,
                            " ", rpt.bus_name
            print
            print
                column   3, "Date",
                column  11, "Tran Type",
                column  25, "Tran #",
                column  34, "Description",
                column  61, "Amount",
                column  74, "Balance"
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Vendor Ledger";
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.ref_code
            if first_group is null
            then
                let first_group = "N"
            else
                skip to top of page
            end if
            print
                column  34, "BEGINNING BALANCE",
                column  68, rpt.arch_bal using "--,---,-##.&&"

        on every row
            print
                column   1, rpt.doc_date using "mm/dd/yy",
                column  11, rpt.tran_type[1,11],
                column  23, rpt.inv_chk_no[1,10],
                column  34, rpt.doc_desc[1,19],
                column  54, rpt.amount using "--,---,-##.&&",
                column  68, rpt.balance using "--,---,-##.&&"

#        after group of rpt.ref_code
#            skip to top of page

end report
# report1()

