########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_1099.4gs/lowlevel.4gl  1.3  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function before_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification

    # Trap fatal errors
    whenever error call error_handler

    if group_key = "first_row" then
        # insert "on first row" code here
        let rpt.grand_total = 0
        let rpt.messg1 = ""
        let rpt.problm0 = ""
        let rpt.problm1 = ""
        begin work
        lock table stp1099r in exclusive mode
        if sqlca.sqlcode != 0
        then
            let  err_string = "SQL error ",sqlca.sqlcode clipped, " has occured when issuing table lock"
            call end_report(err_string, sqlca.sqlcode)
        end if
        delete from stp1099r
        if sqlca.sqlcode != 0
        then
            let  err_string = "SQL error ",sqlca.sqlcode clipped, " has occured during deleting rows from stp1099r"
            call end_report(err_string, sqlca.sqlcode)
        end if
        return
    end if

end function
# before_group()

#######################################################################
function on_every_row()
#######################################################################
#  this function prepares the report record from the cursor record
#  and other data.
#


#   let rpt.co_name = (MUST SUPPLY)
    let rpt.vend_code = curs.vend_code
    call ap_vendn(rpt.vend_code) returning rpt.vend_name
    let rpt.total_amt = curs.total_amt
    let rpt.grand_total = rpt.grand_total + rpt.total_amt
    insert into stp1099r values (rpt.vend_code, 
       rpt.total_amt, "", "", "", "", "", "", "", "", "", "") 
    if sqlca.sqlcode != 0
    then
        let  err_string = "SQL error ",sqlca.sqlcode clipped, " has occured during inserting rows from stp1099r"
        call end_report(err_string, sqlca.sqlcode)
    end if
    return
end function
# on_every_row()

#######################################################################
function after_group(group_key)
#######################################################################
#
    define
        group_key   char(20)    # group identification


    if group_key = "last_row" then
        # insert "on last row" code here
   #    if rpt.problm0 is null
   #    then
            commit work
            let rpt.messg1 = "No errors have occured during posting"
   #    end if
        
        return
    end if

end function
# after_group()

#######################################################################
function end_report(errmsg, errno)
#######################################################################
#  this function calls the last line of the report for abnormal termination.
#
    define
        errmsg char(80),
        errno integer

        initialize rpt.* to null
        let rpt.problm0 = "***** ", errmsg clipped
        let errmsg = err_get(sqlca.sqlcode)
        let rpt.problm1 = "***** ", errmsg clipped
        let rpt.messg1 = "Due to an error, the above postings will not show in the 1099 table"
        call ml_output()
        finish report report1
        rollback work
        exit program(1)

end function
# end_report()
