########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_1099.4gs/midlevel.4gl  1.2  Delta: 1/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function ml_join()
#######################################################################
#
    define
        quote    char(1)    # storage for the quote

    # Trap fatal errors
    whenever error call error_handler

    let quote = "\""
    let ct.sel_join =
       "stpvendr.print_1099 = ", quote, "Y", quote, " and ",
       "stpvendr.vend_code = stxtranr.ref_code and ",
       "stxtranr.orig_journal in ",
       "(", quote, "PU", quote,
       ",", quote, "CD", quote, ") and ",
       "stxtranr.orig_journal = stgactvd.orig_journal"
    return
end function
# ml_join()

#######################################################################
function ml_filter()
#######################################################################
#
    let ct.sel_filter =
        "stxtranr.doc_no = stgactvd.doc_no and ",
        "stgactvd.acct_no = stpractr.acct_no and ",
        "stgactvd.department = stpractr.department"
    return
end function
# ml_filter()

#######################################################################
function ml_order()
#######################################################################
#
    let ct.sel_order = ""
    return
end function
# ml_order()

#######################################################################
function ml_getcount()
#######################################################################
#
    let ct.sel_stmt =
        "select count(distinct vend_code) ",
        "from stpvendr, stxtranr, stgactvd, stpractr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")",
        " and year(stxtranr.doc_date) = ? group by vend_code"
    prepare get_count from ct.sel_stmt
    declare count_cursor cursor for get_count
    open count_cursor using target_year
    let ct.num_rows = 0
    foreach count_cursor
       let ct.num_rows = ct.num_rows + 1
    end foreach
    close count_cursor
    return
end function
# ml_getcount()

#######################################################################
function ml_define_cur()
#######################################################################
#
    let ct.sel_stmt =
        "select ",
            "vend_code, ",
            "sum(stgactvd.amount) ",
        "from stpvendr, stxtranr, stgactvd, stpractr ",
        "where (", ct.sel_join clipped,
        ") and (", ct.sel_filter clipped, ")",
        " and year(stxtranr.doc_date) = ? group by vend_code"
    if ct.sel_order is not null
    then
        let ct.sel_stmt = ct.sel_stmt clipped,
        " order by ", ct.sel_order clipped
    end if
    prepare get_curs from ct.sel_stmt
    declare rpt_cursor cursor for get_curs
    open rpt_cursor using target_year
    return
end function
# ml_define_cur()

#######################################################################
function ml_fetch()
#######################################################################
#
    fetch rpt_cursor into curs_next.*
    return
end function
# ml_fetch()

#######################################################################
function ml_curs_null()
#######################################################################
#  this function sets all of the elements in the curs
#  record to null
#
    initialize curs.* to null
end function
# ml_curs_null()

#######################################################################
function ml_next_null()
#######################################################################
#  this function sets all of the elements in the curs_next
#  record to null
#
    initialize curs_next.* to null
end function
# ml_next_null()

#######################################################################
function ml_curs_prep()
#######################################################################
#  this function transfers data from the curs_next record to the
#  curs record.
#
    let curs.vend_code = curs_next.vend_code
    let curs.total_amt = curs_next.total_amt
end function
# ml_curs_prep()

#######################################################################
function ml_before_break()
#######################################################################
#  this function calls before_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
end function
# ml_before_break()

#######################################################################
function ml_after_break()
#######################################################################
#  this function calls after_group() when appropriate.
#
    define
        no_break    smallint    # set to false if control break
    let no_break = true
end function
# ml_after_break()

#######################################################################
function ml_output()
#######################################################################
#
    output to report report1 (rpt.*)
    return
end function
# ml_output()

#######################################################################
function ml_defaults()
#######################################################################
#  this function sets the ct.* record values
#
    call get_year() returning target_year
    let ct.prcname = "Vendor 1099 Posting"
    let ct.rtmargn = "FourGen Modifiable Accounting"
    let ct.prc_only = "n"
    let ct.destin = "report.out"
    let ct.quiet = "10"
    let rpt.co_name = al_compn()
    let rpt.title_heading = ct.prcname
end function
# ml_defaults()

#######################################################################
function get_year()
# returning target year
#######################################################################
#

    define
        p record
            report_year smallint
        end record

    call sel_wind()
    display " ENTER SELECTION CRITERIA" at 2,1 attribute(white)
    display "Press [DEL] to Cancel or [ESC] to Select" at 2,30 attribute(white)
    open form sel_screen from "dat_sel"
    display form sel_screen

    input p.report_year from s.report_year
       before field report_year
          if p.report_year is null or p.report_year <= 1979
          then
              let p.report_year = 1990
          end if
 
       after field report_year
          if p.report_year is null or p.report_year <= 1979
          then
              call fg_err(1)
              let p.report_year = 1990
          end if
 
    end input

    if int_flag = 1
    then
       let int_flag = 0
       exit program(1)
    end if

    close form sel_screen
    close window selwin

    return p.report_year

end function
# get_year()

