########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ap.4gm/p_1099.4gs/report.4gl  1.3  Delta: 2/5/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            title_heading char(35),
            co_name char(30),
            vend_code like stp1099r.vend_code,
            vend_name char(25),
            total_amt like stp1099r.total_amt,
            grand_total decimal(12),
            messg1 char(80),
            problm0 char(80),
            problm1 char(80)
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    format
        page header
            # Trap fatal errors
            whenever error call error_handler
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = rpt.title_heading
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
            print
                column   1, "---------------------- Vendor 1099 Posti",
                column  41, "ng List --------------------------"
            print
                column   3, "Vendor",
                column  14, "Name",
                column  49, "Total Amount"
            print

        on every row
            print
                column   3, rpt.vend_code,
                column  14, rpt.vend_name,
                column  47, rpt.total_amt using "(((,(((,(((.&&)"

        on last row
            print
            if
                rpt.messg1 is not null
            then
                print
                    column   1, rpt.messg1
            end if
            print
            if
                rpt.problm0 is not null
            then
                print
                    column   1, rpt.problm0
            end if
            if
                rpt.problm1 is not null
            then
                print
                    column   1, rpt.problm1
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"


end report
# report1()

